/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         dfg_parse
#define yylex           dfg_lex
#define yyerror         dfg_error
#define yylval          dfg_lval
#define yychar          dfg_char
#define yydebug         dfg_debug
#define yynerrs         dfg_nerrs


/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 48 "dfgparser.y"


#include <ctype.h>
#include "dfg.h"
#include "symbol.h"
#include "term.h"
#include "foldfg.h"
#include "strings.h"
/* SZ > */
#include "spass_gmp.h"
/* < SZ */

/* Used for the texts from description section. */
typedef struct {
  char*     name;
  char*     author;
  char*     version;
  char*     logic;
  DFG_STATE status;
  char*     description;
  char*     date;
} DFG_DESCRIPTIONTYPE;

static DFG_DESCRIPTIONTYPE dfg_DESC;
static LIST                dfg_AXIOMLIST;
static LIST                dfg_CONJECLIST;
static LIST                dfg_SORTDECLLIST;
/* symbol precedence explicitly defined by user */
static LIST                dfg_USERPRECEDENCE;
static LIST                dfg_AXCLAUSES;
static LIST                dfg_CONCLAUSES;
static LIST                dfg_PROOFLIST;     /* list_of_proofs */
static LIST                dfg_TERMLIST;      /* list_of_terms  */
static BOOL                dfg_IGNORE;      /* tokens are ignored while TRUE */
static FLAGSTORE           dfg_FLAGS;
static PRECEDENCE          dfg_PRECEDENCE;

/* used also in the scanner */
NAT                        dfg_LINENUMBER;
BOOL			   dfg_IGNORETEXT;

/* SZ > */
/* forward declaration; the linearnumber of the first occurrence 
   of a DFG_FRAC or DFG_FRACINFIX symbol */
 NAT top_FIRSTFRAC;
/* < SZ */

void yyerror(const char*);
int  yylex(void);		/* Defined in dfgscanner.l */

static void   dfg_SymbolDecl(int, char*, int);
static SYMBOL dfg_Symbol(char*, NAT);
static void   dfg_SubSort(char*, char*);
static void   dfg_SymbolGenerated(SYMBOL, BOOL, LIST);

static __inline__ TERM dfg_TermCreate(char* Name, LIST Arguments)
/* Look up the symbol, check its arity and create the term */
{
  SYMBOL s;
  NAT    arity;
  arity = list_Length(Arguments);
  s = dfg_Symbol(Name, arity); /* Frees the string */
  if (!symbol_IsVariable(s) && !symbol_IsFunction(s)) {
    misc_StartUserErrorReport();
    misc_UserErrorReport("\n Line %d: is not a function.\n", dfg_LINENUMBER);
    misc_FinishUserErrorReport();
  }
  return term_Create(s, Arguments);
}

static __inline__ TERM dfg_AtomCreate(char* Name, LIST Arguments)
/* Look up the symbol, check its arity and create the atom term */
{
  SYMBOL s;
  s = dfg_Symbol(Name, list_Length(Arguments)); /* Frees the string */
  if (symbol_IsVariable(s) || !symbol_IsPredicate(s)) {
    misc_StartUserErrorReport();
    misc_UserErrorReport("\n Line %d: Symbol is not a predicate.\n", dfg_LINENUMBER);
    misc_FinishUserErrorReport();
  }
  return term_Create(s, Arguments);
}

static __inline__ void dfg_DeleteStringList(LIST List)
{
  list_DeleteWithElement(List, (void (*)(POINTER)) string_StringFree);
}

/**************************************************************/
/* Functions that handle symbols with unspecified arity       */
/**************************************************************/

/* The symbol list holds all symbols whose arity wasn't       */
/* specified in the symbol declaration section.               */
/* If the arity of a symbol was not specified in this section */
/* it is first set to 0. If the symbol occurs with always the */
/* same arity 'A' the arity of this symbol is set to 'A'.     */
static LIST   dfg_SYMBOLLIST;

static void dfg_SymAdd(SYMBOL);
static void dfg_SymCheck(SYMBOL, NAT);
static void dfg_SymCleanUp(void);

/**************************************************************/
/* Functions that handle variable names                       */
/**************************************************************/

/* List of quantified variables in the current input formula. */
/* This list is used to find symbols that by mistake weren't  */
/* declared in the symbol declaration section                 */
/* --> free variables                                         */
/* This is a list of lists, since each time a quantifier is   */
/* reached, a new list is added to the global list.           */
static LIST dfg_VARLIST;
static BOOL dfg_VARDECL;

static void   dfg_VarStart(void);
static void   dfg_VarStop(void);
static void   dfg_VarBacktrack(void);
static void   dfg_VarCheck(void);
static SYMBOL dfg_VarLookup(char*);

#define YYERROR_VERBOSE



/* Line 268 of yacc.c  */
#line 206 "dfgparser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     DFG_AND = 258,
     DFG_AUTHOR = 259,
     DFG_AXIOMS = 260,
     DFG_BEGPROB = 261,
     DFG_BY = 262,
     DFG_CLAUSE = 263,
     DFG_CLOSEBRACE = 264,
     DFG_CLSLIST = 265,
     DFG_CNF = 266,
     DFG_CONJECS = 267,
     DFG_DATE = 268,
     DFG_DECLLIST = 269,
     DFG_DESC = 270,
     DFG_DESCLIST = 271,
     DFG_DNF = 272,
     DFG_DOMPRED = 273,
     DFG_ENDLIST = 274,
     DFG_ENDPROB = 275,
     DFG_EQUAL = 276,
     DFG_EQUIV = 277,
     DFG_EXISTS = 278,
     DFG_FALSE = 279,
     DFG_FORMLIST = 280,
     DFG_FORMULA = 281,
     DFG_FORALL = 282,
     DFG_FREELY = 283,
     DFG_FUNC = 284,
     DFG_GENERATED = 285,
     DFG_GENSET = 286,
     DFG_HYPOTH = 287,
     DFG_IMPLIED = 288,
     DFG_IMPLIES = 289,
     DFG_LOGIC = 290,
     DFG_NAME = 291,
     DFG_NOT = 292,
     DFG_OPENBRACE = 293,
     DFG_OPERAT = 294,
     DFG_OR = 295,
     DFG_PREC = 296,
     DFG_PRED = 297,
     DFG_PRDICAT = 298,
     DFG_PRFLIST = 299,
     DFG_QUANTIF = 300,
     DFG_SATIS = 301,
     DFG_SETFLAG = 302,
     DFG_SETTINGS = 303,
     DFG_SYMLIST = 304,
     DFG_SORT = 305,
     DFG_SORTS = 306,
     DFG_STATUS = 307,
     DFG_STEP = 308,
     DFG_SUBSORT = 309,
     DFG_TERMLIST = 310,
     DFG_TRUE = 311,
     DFG_UNKNOWN = 312,
     DFG_UNSATIS = 313,
     DFG_VERSION = 314,
     DFG_THEORYSYM = 315,
     DFG_FRAC = 316,
     DFG_FRACINFIX = 317,
     DFG_NUM = 318,
     DFG_MINUS1 = 319,
     DFG_NEGNUM = 320,
     DFG_ID = 321,
     DFG_TEXT = 322,
     DFG_FLOATNUM = 323
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 174 "dfgparser.y"

  int       number;
  char*     string;
  SYMBOL    symbol;
  SPROPERTY property;
  TERM      term;
  LIST      list;
  DFG_STATE state;
  BOOL      bool;



/* Line 293 of yacc.c  */
#line 323 "dfgparser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 335 "dfgparser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   556

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  76
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  100
/* YYNRULES -- Number of rules.  */
#define YYNRULES  203
/* YYNRULES -- Number of states.  */
#define YYNSTATES  493

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   323

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      69,    70,     2,     2,    74,     2,    71,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    75,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    72,     2,    73,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,    14,    26,    32,    38,    44,    50,    51,
      57,    58,    64,    65,    71,    73,    75,    77,    84,    85,
      95,    96,   102,   104,   108,   110,   116,   117,   123,   125,
     129,   131,   137,   138,   144,   146,   150,   151,   157,   159,
     163,   165,   171,   172,   178,   180,   184,   186,   192,   194,
     196,   197,   203,   204,   207,   209,   217,   220,   228,   229,
     230,   242,   252,   253,   255,   257,   261,   263,   267,   276,
     278,   280,   281,   284,   285,   293,   294,   297,   299,   304,
     311,   316,   317,   318,   329,   330,   332,   334,   338,   340,
     342,   344,   346,   348,   350,   352,   354,   356,   358,   360,
     362,   364,   366,   368,   370,   374,   376,   381,   382,   385,
     396,   397,   409,   410,   418,   419,   421,   423,   424,   425,
     436,   441,   443,   447,   449,   454,   456,   460,   462,   464,
     466,   473,   478,   479,   487,   488,   490,   492,   501,   506,
     508,   513,   520,   524,   526,   528,   532,   533,   536,   537,
     547,   548,   564,   566,   570,   571,   576,   580,   586,   587,
     591,   593,   595,   597,   599,   601,   603,   605,   607,   609,
     610,   614,   622,   624,   626,   627,   630,   631,   638,   639,
     643,   644,   647,   653,   654,   664,   666,   670,   671,   675,
     680,   685,   692,   697,   699,   703,   705,   712,   713,   716,
     718,   721,   727,   729
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      77,     0,    -1,     6,    69,   126,    70,    71,    78,    87,
     164,    20,    71,    -1,    16,    71,    79,    80,    83,    84,
      81,    82,    85,    19,    71,    -1,    36,    69,    67,    70,
      71,    -1,     4,    69,    67,    70,    71,    -1,    52,    69,
      86,    70,    71,    -1,    15,    69,    67,    70,    71,    -1,
      -1,    59,    69,    67,    70,    71,    -1,    -1,    35,    69,
      67,    70,    71,    -1,    -1,    13,    69,    67,    70,    71,
      -1,    46,    -1,    58,    -1,    57,    -1,    88,   104,   115,
     129,   148,   160,    -1,    -1,    49,    71,    89,    92,    95,
      97,   100,    19,    71,    -1,    -1,    29,    72,    90,    73,
      71,    -1,    91,    -1,    90,    74,    91,    -1,   126,    -1,
      69,   126,    74,   103,    70,    -1,    -1,    43,    72,    93,
      73,    71,    -1,    94,    -1,    93,    74,    94,    -1,   126,
      -1,    69,   126,    74,   103,    70,    -1,    -1,    51,    72,
      96,    73,    71,    -1,   126,    -1,    96,    74,   126,    -1,
      -1,    39,    72,    98,    73,    71,    -1,    99,    -1,    98,
      74,    99,    -1,   126,    -1,    69,   126,    74,   103,    70,
      -1,    -1,    45,    72,   101,    73,    71,    -1,   102,    -1,
     101,    74,   102,    -1,   126,    -1,    69,   126,    74,   103,
      70,    -1,    64,    -1,    63,    -1,    -1,    14,    71,   105,
      19,    71,    -1,    -1,   105,   106,    -1,   109,    -1,    54,
      69,   126,    74,   126,    70,    71,    -1,   141,    71,    -1,
      42,    69,   126,    74,   112,    70,    71,    -1,    -1,    -1,
      27,    69,    72,   107,   127,   108,    73,    74,   141,    70,
      71,    -1,    50,   126,   110,    30,     7,    72,   111,    73,
      71,    -1,    -1,    28,    -1,   126,    -1,   111,    74,   126,
      -1,   126,    -1,   112,    74,   126,    -1,    25,    69,   114,
      70,    71,   116,    19,    71,    -1,     5,    -1,    12,    -1,
      -1,   115,   113,    -1,    -1,   116,    26,    69,   121,   117,
      70,    71,    -1,    -1,    74,   126,    -1,   141,    -1,    37,
      69,   118,    70,    -1,   123,    69,   118,    74,   118,    70,
      -1,   124,    69,   122,    70,    -1,    -1,    -1,   125,    69,
      72,   119,   127,   120,    73,    74,   118,    70,    -1,    -1,
     118,    -1,   118,    -1,   122,    74,   118,    -1,    22,    -1,
      33,    -1,    34,    -1,     3,    -1,    40,    -1,    23,    -1,
      27,    -1,    66,    -1,    63,    -1,    65,    -1,    64,    -1,
      47,    -1,    18,    -1,    41,    -1,    60,    -1,   128,    -1,
     127,    74,   128,    -1,   126,    -1,   126,    69,   126,    70,
      -1,    -1,   129,   130,    -1,    10,    69,   114,    74,    11,
      70,    71,   132,    19,    71,    -1,    -1,    10,    69,   114,
      74,    17,    70,    71,   131,   142,    19,    71,    -1,    -1,
     132,     8,    69,   133,   117,    70,    71,    -1,    -1,   134,
      -1,   137,    -1,    -1,    -1,    27,    69,    72,   135,   127,
     136,    73,    74,   137,    70,    -1,    40,    69,   138,    70,
      -1,   139,    -1,   138,    74,   139,    -1,   141,    -1,    37,
      69,   141,    70,    -1,   141,    -1,   140,    74,   141,    -1,
     126,    -1,    56,    -1,    24,    -1,    21,    69,   146,    74,
     146,    70,    -1,   126,    69,   147,    70,    -1,    -1,   142,
       8,    69,   143,   117,    70,    71,    -1,    -1,   144,    -1,
     145,    -1,    23,    69,    72,   140,    73,    74,   145,    70,
      -1,     3,    69,   138,    70,    -1,   126,    -1,   126,    69,
     147,    70,    -1,    61,    69,   126,    74,   126,    70,    -1,
     126,    62,   126,    -1,    68,    -1,   146,    -1,   147,    74,
     146,    -1,    -1,   148,   149,    -1,    -1,    44,    69,   126,
      70,    71,   150,   151,    19,    71,    -1,    -1,   151,    53,
      69,   155,    74,   159,    74,   126,    74,    72,   152,    73,
     153,    70,    71,    -1,   155,    -1,   152,    74,   155,    -1,
      -1,    74,    72,   154,    73,    -1,   155,    75,   155,    -1,
     154,    74,   155,    75,   155,    -1,    -1,   157,   156,   158,
      -1,   126,    -1,    37,    -1,    22,    -1,    33,    -1,    34,
      -1,     3,    -1,    40,    -1,    27,    -1,    23,    -1,    -1,
      69,   122,    70,    -1,    69,    72,   127,    73,    74,   118,
      70,    -1,   134,    -1,   144,    -1,    -1,   160,   161,    -1,
      -1,    55,    71,   162,   163,    19,    71,    -1,    -1,   163,
     146,    71,    -1,    -1,   164,   165,    -1,    31,    71,   173,
      19,    71,    -1,    -1,    48,    69,   126,   166,    70,    71,
     167,    19,    71,    -1,    67,    -1,    38,   168,     9,    -1,
      -1,   168,   169,    71,    -1,    41,    69,   170,    70,    -1,
      18,    69,   175,    70,    -1,    47,    69,    66,    74,   103,
      70,    -1,    60,    69,   175,    70,    -1,   171,    -1,   170,
      74,   171,    -1,   126,    -1,    69,   126,    74,    63,   172,
      70,    -1,    -1,    74,    66,    -1,   174,    -1,   173,   174,
      -1,    32,    72,   175,    73,    71,    -1,   126,    -1,   175,
      74,   126,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   221,   221,   233,   244,   248,   252,   256,   260,   261,
     265,   266,   270,   271,   275,   276,   277,   284,   296,   297,
     306,   307,   310,   311,   314,   315,   319,   320,   323,   324,
     327,   328,   331,   332,   335,   336,   339,   340,   343,   344,
     347,   348,   351,   352,   355,   356,   359,   360,   363,   364,
     371,   372,   377,   378,   381,   382,   384,   385,   387,   388,
     387,   397,   401,   402,   405,   406,   409,   410,   417,   427,
     428,   431,   432,   435,   436,   450,   451,   454,   455,   457,
     459,   461,   462,   461,   469,   470,   473,   475,   479,   480,
     481,   484,   485,   488,   489,   492,   498,   500,   502,   504,
     506,   508,   510,   514,   516,   520,   531,   555,   556,   559,
     569,   568,   575,   576,   590,   591,   594,   595,   596,   595,
     603,   607,   609,   613,   614,   618,   619,   622,   624,   626,
     628,   630,   637,   638,   641,   642,   645,   646,   649,   657,
     659,   662,   711,   759,   836,   838,   846,   847,   851,   850,
     864,   865,   886,   888,   893,   894,   897,   905,   916,   915,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   938,
     939,   940,   943,   944,   952,   953,   956,   956,   963,   964,
     971,   972,   975,   976,   976,   984,   987,   990,   991,   994,
     995,  1015,  1025,  1041,  1042,  1045,  1057,  1074,  1075,  1092,
    1093,  1096,  1100,  1101
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DFG_AND", "DFG_AUTHOR", "DFG_AXIOMS",
  "DFG_BEGPROB", "DFG_BY", "DFG_CLAUSE", "DFG_CLOSEBRACE", "DFG_CLSLIST",
  "DFG_CNF", "DFG_CONJECS", "DFG_DATE", "DFG_DECLLIST", "DFG_DESC",
  "DFG_DESCLIST", "DFG_DNF", "DFG_DOMPRED", "DFG_ENDLIST", "DFG_ENDPROB",
  "DFG_EQUAL", "DFG_EQUIV", "DFG_EXISTS", "DFG_FALSE", "DFG_FORMLIST",
  "DFG_FORMULA", "DFG_FORALL", "DFG_FREELY", "DFG_FUNC", "DFG_GENERATED",
  "DFG_GENSET", "DFG_HYPOTH", "DFG_IMPLIED", "DFG_IMPLIES", "DFG_LOGIC",
  "DFG_NAME", "DFG_NOT", "DFG_OPENBRACE", "DFG_OPERAT", "DFG_OR",
  "DFG_PREC", "DFG_PRED", "DFG_PRDICAT", "DFG_PRFLIST", "DFG_QUANTIF",
  "DFG_SATIS", "DFG_SETFLAG", "DFG_SETTINGS", "DFG_SYMLIST", "DFG_SORT",
  "DFG_SORTS", "DFG_STATUS", "DFG_STEP", "DFG_SUBSORT", "DFG_TERMLIST",
  "DFG_TRUE", "DFG_UNKNOWN", "DFG_UNSATIS", "DFG_VERSION", "DFG_THEORYSYM",
  "DFG_FRAC", "DFG_FRACINFIX", "DFG_NUM", "DFG_MINUS1", "DFG_NEGNUM",
  "DFG_ID", "DFG_TEXT", "DFG_FLOATNUM", "'('", "')'", "'.'", "'['", "']'",
  "','", "':'", "$accept", "problem", "description", "name", "author",
  "status", "desctext", "versionopt", "logicopt", "dateopt", "log_state",
  "logicalpart", "symbollistopt", "functionsopt", "functionlist", "func",
  "predicatesopt", "predicatelist", "pred", "sortsopt", "sortlist",
  "operatorsopt", "operatorlist", "op", "quantifiersopt", "quantifierlist",
  "quant", "number", "declarationlistopt", "decllistopt", "decl", "$@1",
  "$@2", "gendecl", "freelyopt", "funclist", "sortdecl", "formulalist",
  "origin", "formulalistsopt", "formulalistopt", "labelopt", "formula",
  "$@3", "$@4", "formulaopt", "arglist", "binsymbol", "nsymbol",
  "quantsymbol", "id", "qtermlist", "qterm", "clauselistsopt",
  "clauselist", "$@5", "cnfclausesopt", "cnfclauseopt", "cnfclause", "$@6",
  "$@7", "cnfclausebody", "litlist", "lit", "atomlist", "atom",
  "dnfclausesopt", "dnfclauseopt", "dnfclause", "dnfclausebody", "term",
  "termlist", "prooflistsopt", "prooflist", "$@8", "prooflistopt",
  "parentlist", "assoclistopt", "assoclist", "id_or_formula", "$@9",
  "anysymbol", "optargs", "clause", "listOfTermsopt", "listOfTerms",
  "$@10", "terms", "settinglistsopt", "settinglist", "$@11", "flags",
  "spassflags", "spassflag", "preclist", "precitem", "statopt",
  "gsettings", "gsetting", "labellist", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,    40,
      41,    46,    91,    93,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    76,    77,    78,    79,    80,    81,    82,    83,    83,
      84,    84,    85,    85,    86,    86,    86,    87,    88,    88,
      89,    89,    90,    90,    91,    91,    92,    92,    93,    93,
      94,    94,    95,    95,    96,    96,    97,    97,    98,    98,
      99,    99,   100,   100,   101,   101,   102,   102,   103,   103,
     104,   104,   105,   105,   106,   106,   106,   106,   107,   108,
     106,   109,   110,   110,   111,   111,   112,   112,   113,   114,
     114,   115,   115,   116,   116,   117,   117,   118,   118,   118,
     118,   119,   120,   118,   121,   121,   122,   122,   123,   123,
     123,   124,   124,   125,   125,   126,   126,   126,   126,   126,
     126,   126,   126,   127,   127,   128,   128,   129,   129,   130,
     131,   130,   132,   132,   133,   133,   134,   135,   136,   134,
     137,   138,   138,   139,   139,   140,   140,   141,   141,   141,
     141,   141,   142,   142,   143,   143,   144,   144,   145,   146,
     146,   146,   146,   146,   147,   147,   148,   148,   150,   149,
     151,   151,   152,   152,   153,   153,   154,   154,   156,   155,
     157,   157,   157,   157,   157,   157,   157,   157,   157,   158,
     158,   158,   159,   159,   160,   160,   162,   161,   163,   163,
     164,   164,   165,   166,   165,   167,   167,   168,   168,   169,
     169,   169,   169,   170,   170,   171,   171,   172,   172,   173,
     173,   174,   175,   175
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,    10,    11,     5,     5,     5,     5,     0,     5,
       0,     5,     0,     5,     1,     1,     1,     6,     0,     9,
       0,     5,     1,     3,     1,     5,     0,     5,     1,     3,
       1,     5,     0,     5,     1,     3,     0,     5,     1,     3,
       1,     5,     0,     5,     1,     3,     1,     5,     1,     1,
       0,     5,     0,     2,     1,     7,     2,     7,     0,     0,
      11,     9,     0,     1,     1,     3,     1,     3,     8,     1,
       1,     0,     2,     0,     7,     0,     2,     1,     4,     6,
       4,     0,     0,    10,     0,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     4,     0,     2,    10,
       0,    11,     0,     7,     0,     1,     1,     0,     0,    10,
       4,     1,     3,     1,     4,     1,     3,     1,     1,     1,
       6,     4,     0,     7,     0,     1,     1,     8,     4,     1,
       4,     6,     3,     1,     1,     3,     0,     2,     0,     9,
       0,    15,     1,     3,     0,     4,     3,     5,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       3,     7,     1,     1,     0,     2,     0,     6,     0,     3,
       0,     2,     5,     0,     9,     1,     3,     0,     3,     4,
       4,     6,     4,     1,     3,     1,     6,     0,     2,     1,
       2,     5,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     1,   100,   101,    99,   102,    96,
      98,    97,    95,     0,     0,     0,     0,    18,     0,     0,
     180,    50,     0,     0,    20,     0,     0,    71,     0,     0,
       8,     0,    26,     0,     0,     0,   181,    52,   107,     0,
       0,     0,    10,     0,     0,    32,     2,     0,     0,     0,
       0,    72,   146,     0,     0,     0,     0,     0,     0,     0,
      22,    24,     0,     0,    36,     0,     0,   199,   183,     0,
       0,   129,     0,     0,     0,     0,   128,    53,    54,   127,
       0,     0,     0,   108,   174,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,    30,     0,     0,
      42,     0,     0,   200,     0,    51,     0,     0,     0,    62,
       0,     0,    56,    69,    70,     0,     0,     0,   147,    17,
       5,     0,     0,     0,     0,    12,     0,    21,    23,     0,
       0,     0,     0,    34,     0,     0,     0,   202,     0,   182,
       0,     0,   143,   139,     0,    58,     0,    63,     0,     0,
     144,     0,     0,     0,     0,     0,   175,     9,     0,    14,
      16,    15,     0,     0,     0,     0,    49,    48,     0,     0,
      27,    29,     0,     0,     0,     0,    38,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   131,     0,    73,     0,     0,   176,    11,     0,     0,
       0,     0,    25,     0,    33,    35,     0,     0,     0,     0,
       0,    44,    46,    19,   201,   203,   187,   185,     0,     0,
     142,     0,     0,   105,    59,   103,     0,    66,     0,     0,
     145,     0,     0,     0,     0,   178,     6,     0,     0,     3,
      31,     0,    37,    39,     0,     0,     0,     0,     0,     0,
     140,   130,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   148,     0,     7,     0,     0,     0,    43,
      45,   186,     0,     0,     0,     0,     0,   184,     0,     0,
     104,     0,    57,    67,     0,    64,    55,    68,    84,   112,
     110,   150,     0,     0,    13,    41,     0,     0,     0,     0,
       0,   188,   141,   106,     0,     0,     0,    91,    88,    93,
      94,    89,    90,     0,    92,    85,    75,     0,     0,     0,
      77,     0,   132,     0,   177,   179,    47,     0,     0,   195,
       0,   193,     0,     0,     0,    61,    65,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   190,     0,
     189,     0,     0,   192,     0,     0,    76,     0,     0,    86,
       0,    81,   114,   109,     0,     0,   149,     0,     0,   194,
       0,    60,    78,    74,     0,    80,     0,     0,     0,     0,
      75,   115,   116,   134,   111,   165,   162,   168,   167,   163,
     164,   161,   166,   160,     0,   158,   197,   191,     0,    87,
      82,     0,     0,     0,     0,     0,    75,   135,   136,     0,
     169,     0,     0,    79,     0,   117,     0,     0,   121,   123,
       0,     0,     0,     0,   172,   173,     0,     0,   159,   198,
     196,     0,     0,     0,   120,     0,   113,     0,     0,     0,
       0,     0,     0,     0,   118,     0,   122,   138,     0,   125,
     133,     0,     0,   170,     0,     0,   124,     0,     0,     0,
       0,    83,     0,     0,   126,     0,     0,     0,     0,     0,
     152,     0,     0,   137,   154,     0,   171,   119,     0,     0,
     153,     0,     0,     0,     0,   151,   155,     0,     0,     0,
     156,     0,   157
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,    17,    23,    30,    90,   125,    42,    57,   165,
     162,    20,    21,    32,    59,    60,    45,    95,    96,    64,
     132,   100,   175,   176,   136,   210,   211,   168,    27,    49,
      77,   187,   254,    78,   148,   284,   226,    51,   115,    38,
     231,   339,   359,   377,   414,   316,   360,   317,   318,   319,
      79,   224,   225,    52,    83,   322,   321,   380,   381,   432,
     455,   382,   417,   418,   448,   320,   345,   406,   407,   408,
     150,   151,    84,   118,   291,   323,   469,   479,   483,   394,
     410,   395,   428,   426,   119,   156,   235,   264,    25,    36,
     104,   218,   247,   276,   330,   331,   412,    66,    67,   138
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -371
static const yytype_int16 yypact[] =
{
      28,   -55,    26,   161,  -371,  -371,  -371,  -371,  -371,  -371,
    -371,  -371,  -371,   -18,     2,    63,    16,    45,    61,    33,
    -371,    98,    50,   120,   109,   -16,    73,  -371,    85,   105,
     110,   144,   129,   152,   157,   173,  -371,  -371,   222,   174,
     181,   186,   224,   149,   185,   214,  -371,   230,   161,   339,
     203,  -371,   268,   210,   217,   223,   220,   239,   161,    81,
    -371,  -371,   204,   221,   257,   226,   -12,  -371,  -371,   231,
     232,  -371,   235,   237,   161,   243,  -371,  -371,  -371,   244,
     247,    12,   246,  -371,   272,  -371,   248,   250,   254,   255,
     311,   253,   260,   149,   161,    88,  -371,  -371,   161,   262,
     287,   161,   265,  -371,   267,  -371,    82,   266,   161,   312,
     161,    82,  -371,  -371,  -371,   269,    12,   274,  -371,   295,
    -371,   280,   282,    -9,   284,   342,   100,  -371,  -371,   285,
     290,   204,    92,  -371,   211,   293,   337,  -371,   103,  -371,
     291,   298,  -371,   -41,   294,  -371,   296,  -371,   341,   302,
    -371,    -6,   306,   304,   161,   308,  -371,  -371,   313,  -371,
    -371,  -371,   321,   315,   314,   375,  -371,  -371,   326,   100,
    -371,  -371,   329,   161,   161,   121,  -371,  -371,   219,   330,
     335,   161,   -32,   161,   161,    82,    82,   161,   161,   390,
     161,  -371,    82,  -371,     5,   338,  -371,  -371,   348,   343,
     345,   349,  -371,   352,  -371,  -371,   353,   354,   211,   161,
     125,  -371,  -371,  -371,  -371,  -371,  -371,  -371,   404,   356,
    -371,     0,   358,   340,   357,  -371,    19,  -371,   360,   363,
    -371,    32,   364,   365,   355,  -371,  -371,   368,   366,  -371,
    -371,   100,  -371,  -371,   369,   371,   219,     9,   373,   161,
    -371,  -371,   161,   161,   367,   374,   161,   161,   377,   378,
     381,   380,   382,  -371,   281,  -371,   383,   376,   100,  -371,
    -371,  -371,   386,   388,   389,   392,   396,  -371,   398,   399,
    -371,   385,  -371,  -371,   127,  -371,  -371,  -371,    93,  -371,
    -371,  -371,   402,   403,  -371,  -371,   401,   161,   245,   409,
     161,  -371,  -371,  -371,   400,   405,   161,  -371,  -371,  -371,
    -371,  -371,  -371,   408,  -371,  -371,   406,   410,   412,   413,
    -371,    11,  -371,   -14,  -371,  -371,  -371,    36,   161,  -371,
      39,  -371,   415,    48,   416,  -371,  -371,    93,   161,   417,
      93,    93,   411,   421,   420,    58,   422,   423,  -371,   424,
    -371,   245,   100,  -371,   425,   427,  -371,   428,   426,  -371,
      51,  -371,   -15,  -371,   432,   431,  -371,   170,   407,  -371,
     433,  -371,  -371,  -371,    93,  -371,    93,   161,   435,   436,
     406,  -371,  -371,     8,  -371,  -371,  -371,  -371,  -371,  -371,
    -371,  -371,  -371,  -371,   434,  -371,   437,  -371,   439,  -371,
     357,   438,   351,   442,   444,   445,   406,  -371,  -371,     6,
     446,   429,   447,  -371,   379,  -371,   449,    62,  -371,  -371,
     448,   351,   450,   451,  -371,  -371,   452,    20,  -371,  -371,
    -371,   453,   161,   400,  -371,   351,  -371,    65,   400,   454,
     161,   161,    67,    93,   357,   458,  -371,  -371,   146,  -371,
    -371,   455,   158,  -371,   460,   443,  -371,   457,   400,   461,
     462,  -371,   463,   491,  -371,   170,    93,   466,   464,   165,
    -371,   465,   468,  -371,   467,   170,  -371,  -371,   470,   469,
    -371,   170,   472,   167,   471,  -371,  -371,   170,   170,   473,
    -371,   170,  -371
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -371,  -371,  -371,  -371,  -371,  -371,  -371,  -371,  -371,  -371,
    -371,  -371,  -371,  -371,  -371,   414,  -371,  -371,   393,  -371,
    -371,  -371,  -371,   324,  -371,  -371,   277,  -166,  -371,  -371,
    -371,  -371,  -371,  -371,  -371,  -371,  -371,  -371,   440,  -371,
    -371,  -370,  -275,  -371,  -371,  -371,   113,  -371,  -371,  -371,
      -3,  -369,   292,  -371,  -371,  -371,  -371,  -371,   111,  -371,
    -371,    77,   126,   114,  -371,   -48,  -371,  -371,   141,    89,
    -104,   370,  -371,  -371,  -371,  -371,  -371,  -371,  -371,  -158,
    -371,  -371,  -371,  -371,  -371,  -371,  -371,  -371,  -371,  -371,
    -371,  -371,  -371,  -371,  -371,   200,  -371,  -371,   487,  -219
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      13,    80,   144,   203,    33,   346,   216,   102,   400,   404,
     403,   404,   378,   315,     3,    34,   232,   113,   271,   343,
      65,   184,   233,   307,   114,   379,     4,   272,   185,   405,
     344,   405,    35,   378,     1,   217,   423,   159,     5,   347,
      61,    70,   308,   309,    71,    68,   379,   310,   160,   161,
     273,   259,    14,   311,   312,    91,   274,   313,   260,    97,
     314,     6,   355,   444,   191,   358,   364,     7,   192,   275,
     250,   109,   452,    15,   192,   267,    76,   365,   327,    16,
       8,   333,   222,     9,    10,    11,    12,    18,   230,   255,
      61,   129,   441,   256,    19,   133,   307,    22,   137,   398,
       5,   399,   296,   143,    24,   146,   348,   149,   143,   350,
     181,     5,    26,   351,    70,   308,   309,    71,   353,    28,
     310,   375,   181,     6,    29,   376,   311,   312,    97,     7,
     313,   177,   434,   314,     6,   447,   435,   453,    31,   435,
       7,   376,     8,   141,    37,     9,    10,    11,    12,    76,
     142,   195,    39,     8,    92,    93,     9,    10,    11,    12,
     293,   130,   131,   166,   167,   172,   173,     5,   454,    41,
     205,   206,    44,   385,    40,   212,   180,   181,   215,     5,
     219,   220,   143,   143,   223,   227,   370,   229,     5,   143,
       6,   471,   386,   387,   207,   208,     7,   388,   245,   246,
     305,   306,     6,   389,   390,   177,   244,   391,     7,     8,
     392,     6,     9,    10,    11,    12,    43,     7,    58,   457,
     458,     8,     5,    46,     9,    10,    11,    12,    47,     5,
       8,   460,   253,     9,    10,    11,    12,     5,   474,   475,
     486,   487,    48,   212,    53,     6,   278,    50,    54,   279,
     223,     7,     6,   283,   285,    55,   334,    62,     7,    56,
       6,   143,    65,     5,     8,    63,     7,     9,    10,    11,
      12,     8,    81,    94,     9,    10,    11,    12,    82,     8,
     174,    85,     9,    10,    11,    12,     6,    86,   209,    88,
      87,    89,     7,    98,   137,   329,    99,   137,   101,     5,
     292,   106,   105,   336,   107,     8,   108,   470,     9,    10,
      11,    12,   110,   111,   328,   116,   117,   480,   112,   120,
     121,   122,     6,   484,   123,   349,   124,   126,     7,   489,
     490,   127,   135,   492,   134,   356,   139,   140,   145,   152,
     147,     8,   141,   154,     9,    10,    11,    12,   329,   142,
     155,   157,   158,   163,   419,   164,   179,     5,    69,   169,
      70,   170,   182,    71,   393,   178,    72,   183,   186,     5,
     188,   189,    70,   419,   223,    71,   190,   193,   194,   196,
       6,    73,   199,   200,   197,   445,     7,   419,   416,    74,
     449,   198,     6,    75,   201,    76,   202,   228,     7,     8,
     204,   213,     9,    10,    11,    12,   214,    76,   234,   252,
     464,     8,   238,   237,     9,    10,    11,    12,     5,   236,
     239,    70,   240,   248,    71,   242,   263,   241,   251,   223,
     249,   253,   257,   258,   261,   262,   266,   451,   223,   265,
     281,     6,   269,   268,   277,   282,   295,     7,   286,   287,
     288,   289,   431,   290,   294,   297,    76,   298,   299,   304,
       8,   300,   393,     9,    10,    11,    12,   301,   302,   303,
     396,   326,   393,   324,   325,   332,   335,   337,   393,   340,
     338,   341,   342,   361,   393,   393,   354,   357,   393,   352,
     362,   363,   367,   366,   404,   429,   371,   372,   368,   373,
     374,   383,   384,   397,   401,   402,   379,   128,   409,   413,
     415,   411,   420,   421,   422,   427,   462,   430,   433,   436,
     424,   439,   438,   270,   171,   450,   440,   443,   456,   459,
     461,   463,   243,   465,   473,   476,   466,   467,   477,   482,
     442,   478,   481,   485,   472,   280,   488,   437,   491,   446,
     425,   369,   468,   103,     0,   221,   153
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-371))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       3,    49,   106,   169,    20,    19,    38,    19,   377,     3,
     380,     3,    27,   288,    69,    31,    11,     5,     9,     8,
      32,    62,    17,     3,    12,    40,     0,    18,    69,    23,
      19,    23,    48,    27,     6,    67,   406,    46,    18,    53,
      43,    21,    22,    23,    24,    48,    40,    27,    57,    58,
      41,    19,    70,    33,    34,    58,    47,    37,    26,    62,
      40,    41,   337,   432,    70,   340,     8,    47,    74,    60,
      70,    74,   441,    71,    74,   241,    56,    19,   297,    16,
      60,   300,   186,    63,    64,    65,    66,    71,   192,    70,
      93,    94,    72,    74,    49,    98,     3,    36,   101,   374,
      18,   376,   268,   106,    71,   108,    70,   110,   111,    70,
      74,    18,    14,    74,    21,    22,    23,    24,    70,    69,
      27,    70,    74,    41,     4,    74,    33,    34,   131,    47,
      37,   134,    70,    40,    41,    70,    74,    70,    29,    74,
      47,    74,    60,    61,    71,    63,    64,    65,    66,    56,
      68,   154,    67,    60,    73,    74,    63,    64,    65,    66,
     264,    73,    74,    63,    64,    73,    74,    18,   443,    59,
     173,   174,    43,     3,    69,   178,    73,    74,   181,    18,
     183,   184,   185,   186,   187,   188,   352,   190,    18,   192,
      41,   466,    22,    23,    73,    74,    47,    27,    73,    74,
      73,    74,    41,    33,    34,   208,   209,    37,    47,    60,
      40,    41,    63,    64,    65,    66,    72,    47,    69,    73,
      74,    60,    18,    71,    63,    64,    65,    66,    71,    18,
      60,    73,    74,    63,    64,    65,    66,    18,    73,    74,
      73,    74,    69,   246,    70,    41,   249,    25,    67,   252,
     253,    47,    41,   256,   257,    69,   304,    72,    47,    35,
      41,   264,    32,    18,    60,    51,    47,    63,    64,    65,
      66,    60,    69,    69,    63,    64,    65,    66,    10,    60,
      69,    71,    63,    64,    65,    66,    41,    70,    69,    69,
      67,    52,    47,    72,   297,   298,    39,   300,    72,    18,
      19,    69,    71,   306,    69,    60,    69,   465,    63,    64,
      65,    66,    69,    69,    69,    69,    44,   475,    71,    71,
      70,    67,    41,   481,    69,   328,    15,    74,    47,   487,
     488,    71,    45,   491,    72,   338,    71,    70,    72,    70,
      28,    60,    61,    69,    63,    64,    65,    66,   351,    68,
      55,    71,    70,    69,   402,    13,    19,    18,    19,    74,
      21,    71,    71,    24,   367,    72,    27,    69,    74,    18,
      74,    30,    21,   421,   377,    24,    74,    71,    74,    71,
      41,    42,    67,    69,    71,   433,    47,   435,    37,    50,
     438,    70,    41,    54,    19,    56,    70,     7,    47,    60,
      71,    71,    63,    64,    65,    66,    71,    56,    70,    69,
     458,    60,    67,    70,    63,    64,    65,    66,    18,    71,
      71,    21,    70,    19,    24,    71,    71,    74,    70,   432,
      74,    74,    72,    70,    70,    70,    70,   440,   441,    71,
      73,    41,    71,    74,    71,    71,    70,    47,    71,    71,
      69,    71,    73,    71,    71,    69,    56,    69,    69,    74,
      60,    69,   465,    63,    64,    65,    66,    71,    70,    70,
      63,    70,   475,    71,    71,    66,    71,    69,   481,    69,
      74,    69,    69,    72,   487,   488,    70,    70,   491,    74,
      69,    71,    69,    71,     3,    66,    71,    70,    74,    71,
      74,    69,    71,    70,    69,    69,    40,    93,    74,    70,
      72,    74,    70,    69,    69,    69,    73,    70,    69,    71,
     409,    70,    72,   246,   131,    71,    74,    74,    70,    74,
      70,    74,   208,    72,    70,    70,    74,    74,    70,    70,
     427,    74,    72,    71,   467,   253,    75,   421,    75,   435,
     409,   351,   463,    66,    -1,   185,   116
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     6,    77,    69,     0,    18,    41,    47,    60,    63,
      64,    65,    66,   126,    70,    71,    16,    78,    71,    49,
      87,    88,    36,    79,    71,   164,    14,   104,    69,     4,
      80,    29,    89,    20,    31,    48,   165,    71,   115,    67,
      69,    59,    83,    72,    43,    92,    71,    71,    69,   105,
      25,   113,   129,    70,    67,    69,    35,    84,    69,    90,
      91,   126,    72,    51,    95,    32,   173,   174,   126,    19,
      21,    24,    27,    42,    50,    54,    56,   106,   109,   126,
     141,    69,    10,   130,   148,    71,    70,    67,    69,    52,
      81,   126,    73,    74,    69,    93,    94,   126,    72,    39,
      97,    72,    19,   174,   166,    71,    69,    69,    69,   126,
      69,    69,    71,     5,    12,   114,    69,    44,   149,   160,
      71,    70,    67,    69,    15,    82,    74,    71,    91,   126,
      73,    74,    96,   126,    72,    45,   100,   126,   175,    71,
      70,    61,    68,   126,   146,    72,   126,    28,   110,   126,
     146,   147,    70,   114,    69,    55,   161,    71,    70,    46,
      57,    58,    86,    69,    13,    85,    63,    64,   103,    74,
      71,    94,    73,    74,    69,    98,    99,   126,    72,    19,
      73,    74,    71,    69,    62,    69,    74,   107,    74,    30,
      74,    70,    74,    71,    74,   126,    71,    71,    70,    67,
      69,    19,    70,   103,    71,   126,   126,    73,    74,    69,
     101,   102,   126,    71,    71,   126,    38,    67,   167,   126,
     126,   147,   146,   126,   127,   128,   112,   126,     7,   126,
     146,   116,    11,    17,    70,   162,    71,    70,    67,    71,
      70,    74,    71,    99,   126,    73,    74,   168,    19,    74,
      70,    70,    69,    74,   108,    70,    74,    72,    70,    19,
      26,    70,    70,    71,   163,    71,    70,   103,    74,    71,
     102,     9,    18,    41,    47,    60,   169,    71,   126,   126,
     128,    73,    71,   126,   111,   126,    71,    71,    69,    71,
      71,   150,    19,   146,    71,    70,   103,    69,    69,    69,
      69,    71,    70,    70,    74,    73,    74,     3,    22,    23,
      27,    33,    34,    37,    40,   118,   121,   123,   124,   125,
     141,   132,   131,   151,    71,    71,    70,   175,    69,   126,
     170,   171,    66,   175,   141,    71,   126,    69,    74,   117,
      69,    69,    69,     8,    19,   142,    19,    53,    70,   126,
      70,    74,    74,    70,    70,   118,   126,    70,   118,   118,
     122,    72,    69,    71,     8,    19,    71,    69,    74,   171,
     103,    71,    70,    71,    74,    70,    74,   119,    27,    40,
     133,   134,   137,    69,    71,     3,    22,    23,    27,    33,
      34,    37,    40,   126,   155,   157,    63,    70,   118,   118,
     127,    69,    69,   117,     3,    23,   143,   144,   145,    74,
     156,    74,   172,    70,   120,    72,    37,   138,   139,   141,
      70,    69,    69,   117,   134,   144,   159,    69,   158,    66,
      70,    73,   135,    69,    70,    74,    71,   138,    72,    70,
      74,    72,   122,    74,   127,   141,   139,    70,   140,   141,
      71,   126,   127,    70,   118,   136,    70,    73,    74,    74,
      73,    70,    73,    74,   141,    72,    74,    74,   145,   152,
     155,   118,   137,    70,    73,    74,    70,    70,    74,   153,
     155,    72,    70,   154,   155,    71,    73,    74,    75,   155,
     155,    75,   155
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 225 "dfgparser.y"
    { string_StringFree((yyvsp[(3) - (10)].string));
					  YYACCEPT; /* Stop immediately */ }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 245 "dfgparser.y"
    { dfg_DESC.name = (yyvsp[(3) - (5)].string); }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 249 "dfgparser.y"
    { dfg_DESC.author = (yyvsp[(3) - (5)].string); }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 253 "dfgparser.y"
    { dfg_DESC.status = (yyvsp[(3) - (5)].state); }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 257 "dfgparser.y"
    { dfg_DESC.description = (yyvsp[(3) - (5)].string); }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 262 "dfgparser.y"
    { dfg_DESC.version = (yyvsp[(3) - (5)].string); }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 267 "dfgparser.y"
    { dfg_DESC.logic = (yyvsp[(3) - (5)].string); }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 272 "dfgparser.y"
    { dfg_DESC.date = (yyvsp[(3) - (5)].string); }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 275 "dfgparser.y"
    { (yyval.state) = DFG_SATISFIABLE; }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 276 "dfgparser.y"
    { (yyval.state) = DFG_UNSATISFIABLE; }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 277 "dfgparser.y"
    { (yyval.state) = DFG_UNKNOWNSTATE; }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 314 "dfgparser.y"
    { dfg_SymbolDecl(DFG_FUNC, (yyvsp[(1) - (1)].string), -2); }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 316 "dfgparser.y"
    { dfg_SymbolDecl(DFG_FUNC, (yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].number)); }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 327 "dfgparser.y"
    { dfg_SymbolDecl(DFG_PRDICAT, (yyvsp[(1) - (1)].string), -2); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 328 "dfgparser.y"
    { dfg_SymbolDecl(DFG_PRDICAT, (yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].number)); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 335 "dfgparser.y"
    { dfg_SymbolDecl(DFG_PRDICAT, (yyvsp[(1) - (1)].string), 1); }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 336 "dfgparser.y"
    { dfg_SymbolDecl(DFG_PRDICAT, (yyvsp[(3) - (3)].string), 1); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 347 "dfgparser.y"
    { dfg_SymbolDecl(DFG_OPERAT, (yyvsp[(1) - (1)].string), -2); }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 348 "dfgparser.y"
    { dfg_SymbolDecl(DFG_OPERAT, (yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].number)); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 359 "dfgparser.y"
    { dfg_SymbolDecl(DFG_QUANTIF, (yyvsp[(1) - (1)].string), -2); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 360 "dfgparser.y"
    { dfg_SymbolDecl(DFG_QUANTIF, (yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].number)); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 363 "dfgparser.y"
    { (yyval.number) = -1; }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 364 "dfgparser.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 383 "dfgparser.y"
    { dfg_SubSort((yyvsp[(3) - (7)].string),(yyvsp[(5) - (7)].string)); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 384 "dfgparser.y"
    { dfg_SORTDECLLIST = list_Nconc(dfg_SORTDECLLIST,list_List(list_PairCreate(NULL,(yyvsp[(1) - (2)].term)))); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 386 "dfgparser.y"
    { string_StringFree((yyvsp[(3) - (7)].string)); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 387 "dfgparser.y"
    { dfg_VarStart(); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 388 "dfgparser.y"
    { dfg_VarStop();  }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 389 "dfgparser.y"
    { TERM term;
					  dfg_VarBacktrack();
					  dfg_VarCheck();
					  term = dfg_CreateQuantifier(fol_All(),(yyvsp[(5) - (11)].list),(yyvsp[(9) - (11)].term));
					  dfg_SORTDECLLIST = list_Nconc(dfg_SORTDECLLIST,list_List(list_PairCreate(NULL,term)));
					}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 398 "dfgparser.y"
    { dfg_SymbolGenerated(dfg_Symbol((yyvsp[(2) - (9)].string),1), (yyvsp[(3) - (9)].bool), (yyvsp[(7) - (9)].list)); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 401 "dfgparser.y"
    { (yyval.bool) = FALSE; }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 402 "dfgparser.y"
    { (yyval.bool) = TRUE; }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 405 "dfgparser.y"
    { (yyval.list) = list_List((yyvsp[(1) - (1)].string)); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 406 "dfgparser.y"
    { (yyval.list) = list_Cons((yyvsp[(3) - (3)].string), (yyvsp[(1) - (3)].list)); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 409 "dfgparser.y"
    { string_StringFree((yyvsp[(1) - (1)].string)); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 410 "dfgparser.y"
    { string_StringFree((yyvsp[(3) - (3)].string)); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 419 "dfgparser.y"
    { list_NReverse((yyvsp[(6) - (8)].list));
                                  if ((yyvsp[(3) - (8)].bool)) /* Axioms */
				    dfg_AXIOMLIST = list_Nconc(dfg_AXIOMLIST, (yyvsp[(6) - (8)].list));
				  else
				    dfg_CONJECLIST = list_Nconc(dfg_CONJECLIST, (yyvsp[(6) - (8)].list));
				}
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 427 "dfgparser.y"
    { (yyval.bool) = TRUE;  }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 428 "dfgparser.y"
    { (yyval.bool) = FALSE; }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 435 "dfgparser.y"
    { (yyval.list) = list_Nil(); }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 437 "dfgparser.y"
    { LIST pair;
					  if ((yyvsp[(4) - (7)].term) == NULL) { /* No term */
					    if ((yyvsp[(5) - (7)].string) != NULL)
					      string_StringFree((yyvsp[(5) - (7)].string));
					    (yyval.list) = (yyvsp[(1) - (7)].list);
					  } else {
					    pair = list_PairCreate((yyvsp[(5) - (7)].string), (yyvsp[(4) - (7)].term));
					    (yyval.list) = list_Cons(pair, (yyvsp[(1) - (7)].list));
					  }
					  dfg_VarCheck();
					}
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 450 "dfgparser.y"
    { (yyval.string) = NULL; }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 451 "dfgparser.y"
    { (yyval.string) = (yyvsp[(2) - (2)].string);   }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 454 "dfgparser.y"
    { (yyval.term) = (yyvsp[(1) - (1)].term); }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 456 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : term_Create(fol_Not(),list_List((yyvsp[(3) - (4)].term))); }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 458 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : term_Create((yyvsp[(1) - (6)].symbol), list_Cons((yyvsp[(3) - (6)].term), list_List((yyvsp[(5) - (6)].term)))); }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 460 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : term_Create((yyvsp[(1) - (4)].symbol), (yyvsp[(3) - (4)].list)); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 461 "dfgparser.y"
    { dfg_VarStart(); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 462 "dfgparser.y"
    { dfg_VarStop(); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 464 "dfgparser.y"
    { dfg_VarBacktrack();
		    (yyval.term) = dfg_IGNORE ? NULL : dfg_CreateQuantifier((yyvsp[(1) - (10)].symbol),(yyvsp[(5) - (10)].list),(yyvsp[(9) - (10)].term));
		  }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 469 "dfgparser.y"
    { (yyval.term) = NULL; }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 470 "dfgparser.y"
    { (yyval.term) = (yyvsp[(1) - (1)].term); }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 474 "dfgparser.y"
    { (yyval.list) = dfg_IGNORE ? list_Nil() : list_List((yyvsp[(1) - (1)].term)); }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 476 "dfgparser.y"
    { (yyval.list) = dfg_IGNORE ? (yyvsp[(1) - (3)].list) : list_Nconc((yyvsp[(1) - (3)].list), list_List((yyvsp[(3) - (3)].term))); }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 479 "dfgparser.y"
    { (yyval.symbol) = fol_Equiv();    }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 480 "dfgparser.y"
    { (yyval.symbol) = fol_Implied();  }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 481 "dfgparser.y"
    { (yyval.symbol) = fol_Implies();  }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 484 "dfgparser.y"
    { (yyval.symbol) = fol_And(); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 485 "dfgparser.y"
    { (yyval.symbol) = fol_Or();  }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 488 "dfgparser.y"
    { (yyval.symbol) = fol_Exist(); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 489 "dfgparser.y"
    { (yyval.symbol) = fol_All(); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 492 "dfgparser.y"
    { if (dfg_IGNORE) {
  					    string_StringFree((yyvsp[(1) - (1)].string));
					    (yyval.string) = NULL;
					  } else
					    (yyval.string) = (yyvsp[(1) - (1)].string);
					}
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 499 "dfgparser.y"
    { (yyval.string) = dfg_IGNORE ? NULL : string_IntToString((yyvsp[(1) - (1)].number)); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 501 "dfgparser.y"
    { (yyval.string) = dfg_IGNORE ? NULL : string_IntToString((yyvsp[(1) - (1)].number)); }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 503 "dfgparser.y"
    { (yyval.string) = dfg_IGNORE ? NULL : string_IntToString(-1); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 505 "dfgparser.y"
    { (yyval.string) = dfg_IGNORE ? NULL : string_StringCopy("set_flag"); }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 507 "dfgparser.y"
    { (yyval.string) = dfg_IGNORE ? NULL : string_StringCopy("set_DomPred"); }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 509 "dfgparser.y"
    { (yyval.string) = dfg_IGNORE ? NULL : string_StringCopy("set_precedence"); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 511 "dfgparser.y"
    { (yyval.string) = dfg_IGNORE ? NULL : string_StringCopy("set_TheorySym"); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 515 "dfgparser.y"
    { (yyval.list) = dfg_IGNORE ? list_Nil() : list_List((yyvsp[(1) - (1)].term)); }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 517 "dfgparser.y"
    { (yyval.list) = dfg_IGNORE ? (yyvsp[(1) - (3)].list) : list_Nconc((yyvsp[(1) - (3)].list), list_List((yyvsp[(3) - (3)].term))); }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 521 "dfgparser.y"
    { if (!dfg_IGNORE) {
		      SYMBOL s = dfg_Symbol((yyvsp[(1) - (1)].string),0);
		      if (!symbol_IsVariable(s)) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Line %d: Symbol is not a variable.\n",dfg_LINENUMBER);
			misc_FinishUserErrorReport();
		      }
		      (yyval.term) = term_Create(s, list_Nil());
		    }
		  }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 532 "dfgparser.y"
    { if (!dfg_IGNORE) {
		      SYMBOL p, v;
		      p = dfg_Symbol((yyvsp[(1) - (4)].string), 1);
		      if (!symbol_IsPredicate(p)) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Line %d: Symbol is not a predicate.\n",dfg_LINENUMBER);
			misc_FinishUserErrorReport();
		      }
		      v = dfg_Symbol((yyvsp[(3) - (4)].string), 0);
		      if (!symbol_IsVariable(v)) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Line %d: Symbol is not a variable.\n",dfg_LINENUMBER);
			misc_FinishUserErrorReport();
		      }
		      (yyval.term) = term_Create(p, list_List(term_Create(v,list_Nil())));
		    }
		  }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 562 "dfgparser.y"
    { list_NReverse((yyvsp[(8) - (10)].list));
                    if ((yyvsp[(3) - (10)].bool)) /* Axioms */
		      dfg_AXCLAUSES = list_Nconc(dfg_AXCLAUSES, (yyvsp[(8) - (10)].list));
		    else
		      dfg_CONCLAUSES = list_Nconc(dfg_CONCLAUSES, (yyvsp[(8) - (10)].list));
		  }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 569 "dfgparser.y"
    { stack_Push((POINTER)dfg_IGNORE); dfg_IGNORE = TRUE; }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 572 "dfgparser.y"
    { dfg_IGNORE = (BOOL)stack_PopResult(); }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 575 "dfgparser.y"
    { (yyval.list) = list_Nil(); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 577 "dfgparser.y"
    { LIST pair;
		    if ((yyvsp[(4) - (7)].term) == NULL) { /* No clause */
		      if ((yyvsp[(5) - (7)].string) != NULL)
			string_StringFree((yyvsp[(5) - (7)].string));
		      (yyval.list) = (yyvsp[(1) - (7)].list);
		    } else {
		      pair = list_PairCreate((yyvsp[(5) - (7)].string), (yyvsp[(4) - (7)].term));
		      (yyval.list) = list_Cons(pair, (yyvsp[(1) - (7)].list));
		    }
		    dfg_VarCheck();
		  }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 590 "dfgparser.y"
    { (yyval.term) = NULL; }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 591 "dfgparser.y"
    { (yyval.term) = (yyvsp[(1) - (1)].term); }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 594 "dfgparser.y"
    { (yyval.term) = (yyvsp[(1) - (1)].term); }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 595 "dfgparser.y"
    { dfg_VarStart(); }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 596 "dfgparser.y"
    { dfg_VarStop();  }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 598 "dfgparser.y"
    { dfg_VarBacktrack();
		    (yyval.term) = dfg_IGNORE ? NULL : dfg_CreateQuantifier(fol_All(),(yyvsp[(5) - (10)].list),(yyvsp[(9) - (10)].term));
		  }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 604 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : term_Create(fol_Or(), (yyvsp[(3) - (4)].list)); }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 608 "dfgparser.y"
    { (yyval.list) = dfg_IGNORE ? list_Nil() : list_List((yyvsp[(1) - (1)].term)); }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 610 "dfgparser.y"
    { (yyval.list) = dfg_IGNORE ? (yyvsp[(1) - (3)].list) : list_Nconc((yyvsp[(1) - (3)].list), list_List((yyvsp[(3) - (3)].term))); }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 613 "dfgparser.y"
    { (yyval.term) = (yyvsp[(1) - (1)].term); }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 615 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? (yyvsp[(3) - (4)].term) : term_Create(fol_Not(),list_List((yyvsp[(3) - (4)].term))); }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 618 "dfgparser.y"
    { (yyval.list) = list_List((yyvsp[(1) - (1)].term)); }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 619 "dfgparser.y"
    { (yyval.list) = list_Nconc((yyvsp[(1) - (3)].list), list_List((yyvsp[(3) - (3)].term))); }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 623 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : dfg_AtomCreate((yyvsp[(1) - (1)].string),list_Nil()); }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 625 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : term_Create(fol_True(),list_Nil()); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 627 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : term_Create(fol_False(),list_Nil()); }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 629 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : term_Create(fol_Equality(),list_Cons((yyvsp[(3) - (6)].term),list_List((yyvsp[(5) - (6)].term)))); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 631 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : dfg_AtomCreate((yyvsp[(1) - (4)].string), (yyvsp[(3) - (4)].list)); }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 658 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : dfg_TermCreate((yyvsp[(1) - (1)].string),list_Nil()); }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 660 "dfgparser.y"
    { (yyval.term) = dfg_IGNORE ? NULL : dfg_TermCreate((yyvsp[(1) - (4)].string), (yyvsp[(3) - (4)].list)); }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 663 "dfgparser.y"
    { 
		    if (!dfg_IGNORE) {
		      /* we first create the canonicalized representation of 
			 the given fraction in order to avoid inconsistent datastructures
			 (i.e. symbol name "2/4" but denotation "1/2") */
		      mpq_t temp;
		      TERM help;
		      int nom, denom;
		      
		      if (! string_StringToInt((yyvsp[(3) - (6)].string), FALSE, &nom)
			  || !string_StringToInt((yyvsp[(5) - (6)].string), FALSE, &denom)) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Line %d: Rational number specified incorrectly: \"frac(%s,%s)\".\n",
					     dfg_LINENUMBER, (yyvsp[(3) - (6)].string), (yyvsp[(5) - (6)].string));
			misc_FinishUserErrorReport();
		      }
		      
		      if (denom == 0) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Line %d: Rational number has 0 denominator: \"frac(%s,%s)\".\n",
					     dfg_LINENUMBER, (yyvsp[(3) - (6)].string), (yyvsp[(5) - (6)].string));
			misc_FinishUserErrorReport();
		      }
		      
		      if (denom < 0) {
			denom *= -1;
			nom *= -1;
		      }

		      mpq_init(temp);
		      mpq_set_si(temp, (signed long int)nom, (unsigned long int) denom);
		      mpq_canonicalize(temp);
		      		      
		      help = dfg_TermCreate(gmp_MPNToName(temp), list_Nil());
		      mpq_clear(temp);
		      string_StringFree((yyvsp[(3) - (6)].string));
		      string_StringFree((yyvsp[(5) - (6)].string));

		      /* save the linenumber of the first DFG_FRAC occurrence */
		      if (top_FIRSTFRAC == 0)
			top_FIRSTFRAC = dfg_LINENUMBER;

		      (yyval.term) = help;
		    } else {
		      (yyval.term) = NULL;
		    }
                  }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 712 "dfgparser.y"
    { 
		    if (!dfg_IGNORE) {
		      /* we first create the canonicalized representation of 
			 the given fraction in order to avoid inconsistent datastructures
			 (i.e. symbol name "2/4" but denotation "1/2") */
		      mpq_t temp;
		      TERM help;
		      int nom, denom;
		      
		      if (! string_StringToInt((yyvsp[(1) - (3)].string), FALSE, &nom)
			  || !string_StringToInt((yyvsp[(3) - (3)].string), FALSE, &denom)) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Line %d: Rational number specified incorrectly: \"%s/%s\".\n",
					     dfg_LINENUMBER, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string));
			misc_FinishUserErrorReport();
		      }
		      
		      if (denom == 0) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Line %d: Rational number has 0 denominator: \"%s/%s\".\n",
					     dfg_LINENUMBER, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string));
			misc_FinishUserErrorReport();
		      }
		      
		      if (denom < 0) {
			denom *= -1;
			nom *= -1;
		      }

		      mpq_init(temp);
		      mpq_set_si(temp, (signed long int)nom, (unsigned long int) denom);
		      mpq_canonicalize(temp);
		      		      
		      help = dfg_TermCreate(gmp_MPNToName(temp), list_Nil());
		      mpq_clear(temp);
		      string_StringFree((yyvsp[(1) - (3)].string));
		      string_StringFree((yyvsp[(3) - (3)].string));

		      /* save the linenumber of the first DFG_FRACINFIX occurrence */
		      if (top_FIRSTFRAC == 0)
			top_FIRSTFRAC = dfg_LINENUMBER;

		      (yyval.term) = help;
		    } else {
		      (yyval.term) = NULL;
		    }
                  }
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 760 "dfgparser.y"
    { 
		    if (!dfg_IGNORE) {
		      /* we first create the canonicalized representation of 
			 the given fraction in order to avoid inconsistent datastructures
			 (i.e. symbol name "2/4" but denotation "1/2") */
		      mpq_t temp;
		      TERM help;
                      char* nomstr;
                      char* denomstr;
		      int nom, denom;
                      int i, j, k;
                      BOOL decpoint;

                      nomstr = (char*) memory_Malloc(sizeof(char)*(strlen((yyvsp[(1) - (1)].string))+1));
                      denomstr = (char*) memory_Malloc(sizeof(char)*(strlen((yyvsp[(1) - (1)].string))+1));

                      i = 0;
                      j = 0;
                      k = 1;
                      decpoint = FALSE;

                      denomstr[0] = '1';
                      while ((yyvsp[(1) - (1)].string)[i]) {
                        if ((yyvsp[(1) - (1)].string)[i] == '.') {
			  decpoint = TRUE;
                          i++;
			} else {
                          nomstr[j] = (yyvsp[(1) - (1)].string)[i];
                          i++;
                          j++;
                          if (decpoint) {
                            denomstr[k] = '0';
                            k++;
			  }
			}
		      }
		      nomstr[j] = '\0';
		      denomstr[k] = '\0';
		      
		      if (! string_StringToInt(nomstr, FALSE, &nom)
			  || !string_StringToInt(denomstr, FALSE, &denom)) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Line %d: Floating-point has too many decimal digits: \"%s\".\n",
					     dfg_LINENUMBER, (yyvsp[(1) - (1)].string));
			misc_FinishUserErrorReport();
		      }
		      
		      mpq_init(temp);
		      mpq_set_si(temp, (signed long int)nom, (unsigned long int) denom);
		      mpq_canonicalize(temp);
		      		      
		      help = dfg_TermCreate(gmp_MPNToName(temp), list_Nil());
		      mpq_clear(temp);
                      j = strlen((yyvsp[(1) - (1)].string));
                      for (i = 0 ; i < j ; i++) {
		        nomstr[i] = '0';
		        denomstr[i] = '0';
		      }
		      nomstr[i] = '\0';
		      denomstr[i] = '\0';

		      string_StringFree((yyvsp[(1) - (1)].string));
		      string_StringFree(nomstr);
		      string_StringFree(denomstr);

		      /* save the linenumber of the first DFG_FRACINFIX occurrence */
		      if (top_FIRSTFRAC == 0)
			top_FIRSTFRAC = dfg_LINENUMBER;

		      (yyval.term) = help;
		    } else {
		      (yyval.term) = NULL;
		    }
                  }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 837 "dfgparser.y"
    { (yyval.list) = dfg_IGNORE ? list_Nil() : list_List((yyvsp[(1) - (1)].term)); }
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 839 "dfgparser.y"
    { (yyval.list) = dfg_IGNORE ? (yyvsp[(1) - (3)].list) : list_Nconc((yyvsp[(1) - (3)].list),list_List((yyvsp[(3) - (3)].term))); }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 851 "dfgparser.y"
    { if (!string_Equal((yyvsp[(3) - (5)].string),"SPASS")) {
		      stack_Push((POINTER)dfg_IGNORE);
		      dfg_IGNORE = TRUE;
		    }
		  }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 858 "dfgparser.y"
    { if (!string_Equal((yyvsp[(3) - (9)].string),"SPASS"))
		      dfg_IGNORE = (BOOL)stack_PopResult();
		    string_StringFree((yyvsp[(3) - (9)].string));
		  }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 867 "dfgparser.y"
    { if (!dfg_IGNORE && (yyvsp[(4) - (15)].string)!=NULL && (yyvsp[(6) - (15)].term)!=NULL && !list_Empty((yyvsp[(11) - (15)].list))) {
		    LIST tupel;
		    RULE Rule = clause_GetOriginFromString((yyvsp[(8) - (15)].string));
		    string_StringFree((yyvsp[(8) - (15)].string));
		    /* Build a tuple (label,clause,parentlist,split level,origin) */
		    tupel = list_Cons((POINTER)(yyvsp[(13) - (15)].number),list_List((POINTER)Rule));
		    tupel = list_Cons((yyvsp[(4) - (15)].string),list_Cons((yyvsp[(6) - (15)].term),list_Cons((yyvsp[(11) - (15)].list),tupel)));
		    dfg_PROOFLIST = list_Cons(tupel, dfg_PROOFLIST);
		  } else {
		    /* ignore DNF clauses and clauses with incomplete data */
		    if ((yyvsp[(4) - (15)].string) != NULL) string_StringFree((yyvsp[(4) - (15)].string));
		    if ((yyvsp[(6) - (15)].term) != NULL) term_Delete((yyvsp[(6) - (15)].term));
		    if ((yyvsp[(8) - (15)].string) != NULL) string_StringFree((yyvsp[(8) - (15)].string));
		    dfg_DeleteStringList((yyvsp[(11) - (15)].list));
		  }
		  dfg_VarCheck();
		}
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 887 "dfgparser.y"
    { (yyval.list) = (dfg_IGNORE||(yyvsp[(1) - (1)].string)==NULL) ? list_Nil() : list_List((yyvsp[(1) - (1)].string)); }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 889 "dfgparser.y"
    { (yyval.list) = (dfg_IGNORE||(yyvsp[(3) - (3)].string)==NULL) ? (yyvsp[(1) - (3)].list) : list_Nconc((yyvsp[(1) - (3)].list), list_List((yyvsp[(3) - (3)].string))); }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 893 "dfgparser.y"
    { (yyval.number) = 0; }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 894 "dfgparser.y"
    { (yyval.number) = (yyvsp[(3) - (4)].number); }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 898 "dfgparser.y"
    { if (!dfg_IGNORE && (yyvsp[(1) - (3)].string)!=NULL && (yyvsp[(3) - (3)].string)!=NULL && string_Equal((yyvsp[(1) - (3)].string),"splitlevel"))
		      string_StringToInt((yyvsp[(3) - (3)].string), TRUE, &(yyval.number));
		    else
		      (yyval.number) = 0;
		    if ((yyvsp[(1) - (3)].string) != NULL) string_StringFree((yyvsp[(1) - (3)].string));
		    if ((yyvsp[(3) - (3)].string) != NULL) string_StringFree((yyvsp[(3) - (3)].string));
		  }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 906 "dfgparser.y"
    { if (!dfg_IGNORE && (yyvsp[(3) - (5)].string)!=NULL && (yyvsp[(5) - (5)].string)!=NULL && string_Equal((yyvsp[(3) - (5)].string),"splitlevel"))
		      string_StringToInt((yyvsp[(5) - (5)].string), TRUE, &(yyval.number));
		    else
		      (yyval.number) = (yyvsp[(1) - (5)].number);
		    if ((yyvsp[(3) - (5)].string) != NULL) string_StringFree((yyvsp[(3) - (5)].string));
		    if ((yyvsp[(5) - (5)].string) != NULL) string_StringFree((yyvsp[(5) - (5)].string));
		  }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 916 "dfgparser.y"
    { stack_Push((POINTER) dfg_IGNORE); dfg_IGNORE = TRUE; }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 918 "dfgparser.y"
    { dfg_IGNORE = (BOOL) stack_PopResult();
		    if ((yyvsp[(3) - (3)].bool)) {
		      if ((yyvsp[(1) - (3)].string) != NULL) string_StringFree((yyvsp[(1) - (3)].string));
		      (yyval.string) = NULL;
		    } else
		      (yyval.string) = (yyvsp[(1) - (3)].string);
		  }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 927 "dfgparser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 928 "dfgparser.y"
    { (yyval.string) = NULL; }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 929 "dfgparser.y"
    { (yyval.string) = NULL; }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 930 "dfgparser.y"
    { (yyval.string) = NULL; }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 931 "dfgparser.y"
    { (yyval.string) = NULL; }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 932 "dfgparser.y"
    { (yyval.string) = NULL; }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 933 "dfgparser.y"
    { (yyval.string) = NULL; }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 934 "dfgparser.y"
    { (yyval.string) = NULL; }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 935 "dfgparser.y"
    { (yyval.string) = NULL; }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 938 "dfgparser.y"
    { (yyval.bool) = FALSE; }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 939 "dfgparser.y"
    { (yyval.bool) = TRUE; }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 940 "dfgparser.y"
    { (yyval.bool) = TRUE; }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 943 "dfgparser.y"
    { (yyval.term) = (yyvsp[(1) - (1)].term);   }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 944 "dfgparser.y"
    { (yyval.term) = NULL; }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 956 "dfgparser.y"
    { dfg_VarStart(); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 957 "dfgparser.y"
    {
                                          dfg_VarStop();
                                          dfg_VarBacktrack();
                                          dfg_VarCheck(); }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 964 "dfgparser.y"
    { dfg_TERMLIST = list_Nconc(dfg_TERMLIST, list_List((yyvsp[(2) - (3)].term))); }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 976 "dfgparser.y"
    { if (string_Equal((yyvsp[(3) - (3)].string),"SPASS"))
					    dfg_IGNORETEXT = FALSE;
					  string_StringFree((yyvsp[(3) - (3)].string));
					}
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 981 "dfgparser.y"
    { dfg_IGNORETEXT = TRUE; }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 984 "dfgparser.y"
    { /* no SPASS flags */
				  string_StringFree((yyvsp[(1) - (1)].string));
				}
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 996 "dfgparser.y"
    { SYMBOL s;
		    for ( ; !list_Empty((yyvsp[(3) - (4)].list)); (yyvsp[(3) - (4)].list) = list_Pop((yyvsp[(3) - (4)].list))) {
		      s = symbol_Lookup(list_Car((yyvsp[(3) - (4)].list)));
		      if (s == 0) {
		        misc_StartUserErrorReport();
		        misc_UserErrorReport("\n Undefined symbol %s", list_Car((yyvsp[(3) - (4)].list)));
			misc_UserErrorReport(" in DomPred list.\n"); 
			misc_FinishUserErrorReport(); 
		      }
		      if (!symbol_IsPredicate(s)) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Symbol %s isn't a predicate", list_Car((yyvsp[(3) - (4)].list)));
			misc_UserErrorReport(" in DomPred list.\n");
			misc_FinishUserErrorReport();
		      }
		      string_StringFree(list_Car((yyvsp[(3) - (4)].list))); 
		      symbol_AddProperty(s, DOMPRED);
		    }
		  }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1016 "dfgparser.y"
    { int flag = flag_Id((yyvsp[(3) - (6)].string));
		    if (flag == -1) {
		      misc_StartUserErrorReport();
		      misc_UserErrorReport("\n Found unknown flag %s", (yyvsp[(3) - (6)].string));
		      misc_FinishUserErrorReport();
		    }
		    string_StringFree((yyvsp[(3) - (6)].string));
		    flag_SetFlagValue(dfg_FLAGS, flag, (yyvsp[(5) - (6)].number));
		  }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1026 "dfgparser.y"
    { SYMBOL s;
		    for ( ; !list_Empty((yyvsp[(3) - (4)].list)); (yyvsp[(3) - (4)].list) = list_Pop((yyvsp[(3) - (4)].list))) {
		      s = symbol_Lookup(list_Car((yyvsp[(3) - (4)].list)));
		      if (s == 0) {
		        misc_StartUserErrorReport();
		        misc_UserErrorReport("\n Undefined symbol %s", list_Car((yyvsp[(3) - (4)].list)));
			misc_UserErrorReport(" in TheorySym list.\n"); 
			misc_FinishUserErrorReport(); 
		      }
		      string_StringFree(list_Car((yyvsp[(3) - (4)].list))); 
		      symbol_AddProperty(s, THEORYSYM);
		    }
		  }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1046 "dfgparser.y"
    { SYMBOL s = symbol_Lookup((yyvsp[(1) - (1)].string));
		      if (s == 0) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Undefined symbol %s ", (yyvsp[(1) - (1)].string));
			misc_UserErrorReport(" in precedence list.\n"); 
			misc_FinishUserErrorReport(); 
		      }
		      string_StringFree((yyvsp[(1) - (1)].string));
		      symbol_SetIncreasedOrdering(dfg_PRECEDENCE, s);
                      dfg_USERPRECEDENCE = list_Cons((POINTER)s, dfg_USERPRECEDENCE);
		    }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1058 "dfgparser.y"
    { SYMBOL s = symbol_Lookup((yyvsp[(2) - (6)].string));
		      if (s == 0) {
			misc_StartUserErrorReport();
			misc_UserErrorReport("\n Undefined symbol %s", (yyvsp[(2) - (6)].string));
			misc_UserErrorReport("in precedence list.\n");
			misc_FinishUserErrorReport(); 
		      }
		      string_StringFree((yyvsp[(2) - (6)].string));
		      symbol_SetIncreasedOrdering(dfg_PRECEDENCE, s);
                      dfg_USERPRECEDENCE = list_Cons((POINTER)s, dfg_USERPRECEDENCE);
		      symbol_SetWeight(s, (yyvsp[(4) - (6)].number));
		      if ((yyvsp[(5) - (6)].property) != 0)
			symbol_AddProperty(s, (yyvsp[(5) - (6)].property));
		    }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1074 "dfgparser.y"
    { (yyval.property) = 0; /* left */ }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1076 "dfgparser.y"
    { if ((yyvsp[(2) - (2)].string)[1] != '\0' ||
			  ((yyvsp[(2) - (2)].string)[0]!='l' && (yyvsp[(2) - (2)].string)[0]!='m' && (yyvsp[(2) - (2)].string)[0]!='r')) {
		         misc_StartUserErrorReport();
			 misc_UserErrorReport("\n Invalid symbol status %s", (yyvsp[(2) - (2)].string));
			 misc_UserErrorReport(" in precedence list.");
			 misc_FinishUserErrorReport();
		      }
		      switch ((yyvsp[(2) - (2)].string)[0]) {
		      case 'm': (yyval.property) = ORDMUL;   break;
		      case 'r': (yyval.property) = ORDRIGHT; break;
		      default:  (yyval.property) = 0;
		      }
		      string_StringFree((yyvsp[(2) - (2)].string));
		    }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1097 "dfgparser.y"
    { dfg_DeleteStringList((yyvsp[(3) - (5)].list)); }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1100 "dfgparser.y"
    { (yyval.list) = list_List((yyvsp[(1) - (1)].string)); }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1101 "dfgparser.y"
    { (yyval.list) = list_Nconc((yyvsp[(1) - (3)].list), list_List((yyvsp[(3) - (3)].string))); }
    break;



/* Line 1806 of yacc.c  */
#line 3383 "dfgparser.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1104 "dfgparser.y"


void yyerror(const char *s)
{
  misc_StartUserErrorReport();
  misc_UserErrorReport("\n Line %i: %s\n", dfg_LINENUMBER, s);
  misc_FinishUserErrorReport();
}

static void dfg_Init(FILE* Input, FLAGSTORE Flags, PRECEDENCE Precedence)
/**************************************************************
  INPUT:   The input file stream for the parser, a flag store and
           a precedence.
  RETURNS: Nothing.
  EFFECT:  The parser and scanner are initialized.
           The parser will use the flag store and the precedence
	   to memorize the settings from the input file.
***************************************************************/
{
  extern FILE* dfg_in;  /* declared in dfgscanner */

  dfg_in               = Input;
  dfg_LINENUMBER       = 1;
  dfg_IGNORETEXT       = TRUE;
  dfg_AXIOMLIST        = list_Nil();
  dfg_CONJECLIST       = list_Nil();
  dfg_SORTDECLLIST     = list_Nil();
  dfg_USERPRECEDENCE   = list_Nil();
  dfg_AXCLAUSES        = list_Nil();
  dfg_CONCLAUSES       = list_Nil();
  dfg_PROOFLIST        = list_Nil();
  dfg_TERMLIST         = list_Nil();
  dfg_SYMBOLLIST       = list_Nil();
  dfg_VARLIST          = list_Nil();
  dfg_VARDECL          = FALSE;
  dfg_IGNORE           = FALSE;
  dfg_FLAGS            = Flags;
  dfg_PRECEDENCE       = Precedence;
  dfg_DESC.name        = (char*) NULL;
  dfg_DESC.author      = (char*) NULL;
  dfg_DESC.version     = (char*) NULL;
  dfg_DESC.logic       = (char*) NULL;
  dfg_DESC.status      = DFG_UNKNOWNSTATE;
  dfg_DESC.description = (char*) NULL;
  dfg_DESC.date        = (char*) NULL;
}


void dfg_Free(void)
/**************************************************************
  INPUT:   None.
  RETURNS: Nothing.
  EFFECT:  Frees memory used by the problem description.
***************************************************************/
{
  if (dfg_DESC.name != NULL)
    string_StringFree(dfg_DESC.name);
  if (dfg_DESC.author != NULL)
    string_StringFree(dfg_DESC.author);
  if (dfg_DESC.version != NULL)
    string_StringFree(dfg_DESC.version);
  if (dfg_DESC.logic != NULL)
    string_StringFree(dfg_DESC.logic);
  if (dfg_DESC.description != NULL)
    string_StringFree(dfg_DESC.description);
  if(dfg_DESC.date != NULL)
    string_StringFree(dfg_DESC.date);
}

const char* dfg_ProblemName(void)
/**************************************************************
  INPUT:   None.
  RETURNS: The problem's name from the description section.
***************************************************************/
{
  return dfg_DESC.name;
}

const char* dfg_ProblemAuthor(void)
/**************************************************************
  INPUT:   None.
  RETURNS: The problem's author from the description section.
***************************************************************/
{
  return dfg_DESC.author;
}

const char* dfg_ProblemVersion(void)
/**************************************************************
  INPUT:   None.
  RETURNS: The problem's version from the description section.
***************************************************************/
{
  return dfg_DESC.version;
}

const char* dfg_ProblemLogic(void)
/**************************************************************
  INPUT:   None.
  RETURNS: The problem's logic from the description section.
***************************************************************/
{
  return dfg_DESC.logic;
}

DFG_STATE dfg_ProblemStatus(void)
/**************************************************************
  INPUT:   None.
  RETURNS: The problem's status from the description section.
***************************************************************/
{
  return dfg_DESC.status;
}

const char* dfg_ProblemStatusString(void)
/**************************************************************
  INPUT:   None.
  RETURNS: The string representation of the problem's status.
***************************************************************/
{
  const char* result = "";

  switch (dfg_DESC.status) {
  case DFG_SATISFIABLE:
    result = "satisfiable"; break;
  case DFG_UNSATISFIABLE:
    result = "unsatisfiable"; break;
  case DFG_UNKNOWNSTATE:
    result = "unknown"; break;
  default:
    misc_StartErrorReport();
    misc_ErrorReport("\n In dfg_ProblemStatusString: Invalid status.\n");
    misc_FinishErrorReport();
  }
  return result;
}

const char* dfg_ProblemDescription(void)
/**************************************************************
  INPUT:   None.
  RETURNS: The problem's description from the description section.
***************************************************************/
{
  return dfg_DESC.description;
}

const char* dfg_ProblemDate(void)
/**************************************************************
  INPUT:   None.
  RETURNS: The problem's date from the description section.
***************************************************************/
{
  return dfg_DESC.date;
}

void dfg_FPrintDescription(FILE* File)
/**************************************************************
  INPUT:   A file stream.
  RETURNS: Nothing.
  EFFECT:  The description section from the input file
           is printed to 'File'. You must call the parser first
           before calling this function.
***************************************************************/
{
  fputs("list_of_descriptions.\n  name(", File);
  if (dfg_DESC.name != NULL)
    fputs(dfg_DESC.name, File);
  else
    fputs("{* *}", File);
  fputs(").\n  author(", File);
  if (dfg_DESC.author != NULL)
    fputs(dfg_DESC.author, File);
  else
    fputs("{* *}", File);
  fputs(").\n", File);
  if (dfg_DESC.version != NULL) {
    fputs("  version(", File);
    fputs(dfg_DESC.version, File);
    fputs(").\n", File);
  }
  if (dfg_DESC.logic != NULL) {
    fputs("  logic(", File);
    fputs(dfg_DESC.logic, File);
    fputs(").\n", File);
  }
  fputs("  status(", File);
  fputs(dfg_ProblemStatusString(), File);
  fputs(").\n  description(", File);
  if (dfg_DESC.description != NULL)
    fputs(dfg_DESC.description, File);
  else
    fputs("{* *}", File);
  fputs(").\n", File);
  if (dfg_DESC.date != NULL) {
    fputs("  date(", File);
    fputs(dfg_DESC.date, File);
    fputs(").\n", File);
  }
  fputs("end_of_list.", File);
}


LIST dfg_DFGParser(FILE* File, FLAGSTORE Flags, PRECEDENCE Precedence,
		   LIST* Axioms, LIST* Conjectures, LIST* SortDecl,
		   LIST* UserDefinedPrecedence)
/**************************************************************
  INPUT:   The input file containing clauses or formulae in DFG syntax,
           a flag store and a precedence used to memorize settings
	   from the file.
           Axioms, Conjectures, SortDecl and UserDefinedPrecedence are
	   pointers to lists used as return values.
  RETURNS: The list of clauses from File.
  EFFECT:  Reads formulae and clauses from the input file.
           The axioms, conjectures, sort declarations and user-defined
	   precedences are appended to the respective lists, the lists
	   are not deleted!
	   All lists except the clause list contain pairs
	   (label, term), where <label> may be NULL, if no
	   label was specified for that term.
	   <UserDefinedPrecedence> contains symbols sorted by decreasing
	   precedence. This list will only be changed, if the precedence
	   is explicitly defined in the input file. This can be done
	   by the 'set_precedence' flag in the SPASS settings list in
	   the DFG input file.
  CAUTION: The weight of the clauses is not correct and the literals
           are not oriented!
***************************************************************/
{
  LIST  scan, tupel;
  TERM  clauseTerm;
  NAT   bottom;

  dfg_Init(File, Flags, Precedence);  /* Initialize the parser and scanner */
  bottom = stack_Bottom();
  dfg_parse();          /* Invoke the parser */
#ifdef CHECK 
  if (!stack_Empty(bottom)) {
    misc_StartErrorReport();
    misc_ErrorReport("\n In dfg_DFGParser: Stack not empty!\n");
    misc_FinishErrorReport();
  }
#endif
  dfg_SymCleanUp();

  /* Remove clause labels and create clauses from the terms */
  for (scan = dfg_AXCLAUSES; !list_Empty(scan); scan = list_Cdr(scan)) {
    tupel = list_Car(scan);
    clauseTerm = list_PairSecond(tupel);
    list_Rplaca(scan, dfg_CreateClauseFromTerm(clauseTerm,TRUE, Flags, Precedence));
    if (list_PairFirst(tupel) != NULL)        /* Label is defined */
      string_StringFree(list_PairFirst(tupel));  /* Delete the label */
    list_PairFree(tupel);
  }
  /* Since dfg_CreateClauseFromTerm() returns NULL for trivial tautologies */
  /* we now delete those NULL pointers from the clause list.               */
  dfg_AXCLAUSES = list_PointerDeleteElement(dfg_AXCLAUSES, NULL);
  for (scan = dfg_CONCLAUSES; !list_Empty(scan); scan = list_Cdr(scan)) {
    tupel = list_Car(scan);
    clauseTerm = list_PairSecond(tupel);
    list_Rplaca(scan, dfg_CreateClauseFromTerm(clauseTerm,FALSE, Flags, Precedence));
    if (list_PairFirst(tupel) != NULL)        /* Label is defined */
      string_StringFree(list_PairFirst(tupel));  /* Delete the label */
    list_PairFree(tupel);
  }
  /* Since dfg_CreateClauseFromTerm() returns NULL for trivial tautologies */
  /* we now delete those NULL pointers from the clause list.               */
  dfg_CONCLAUSES = list_PointerDeleteElement(dfg_CONCLAUSES, NULL);

  /* Delete the proof list */
  dfg_DeleteProofList(dfg_PROOFLIST);

  /* Delete the list_of_terms, since it'll be ignored */
  term_DeleteTermList(dfg_TERMLIST);

  scan = list_Nconc(dfg_AXCLAUSES, dfg_CONCLAUSES);

  *Axioms      = list_Nconc(*Axioms, dfg_AXIOMLIST);
  *Conjectures = list_Nconc(*Conjectures, dfg_CONJECLIST);
  *SortDecl    = list_Nconc(*SortDecl, dfg_SORTDECLLIST);
  list_NReverse(dfg_USERPRECEDENCE);
  *UserDefinedPrecedence = list_Nconc(*UserDefinedPrecedence, dfg_USERPRECEDENCE);

  return scan;
}


LIST dfg_ProofParser(FILE* File, FLAGSTORE Flags, PRECEDENCE Precedence)
/**************************************************************
  INPUT:   The input file containing clauses in DFG syntax,
           a flag store and a precedence used to memorize settings
           from the file.
  RETURNS: A list of tuples (label,clause,justificationlist,splitlevel,origin)
           representing a proof.
  EFFECT:  Reads inputs clauses with labels and the proof lists
           from the input file.
           The elements of the list are lists with five items.
	   1. the label (a string) of a clause,
	   2. the clause in TERM format,
           3. the list of justification labels (strings, too),
           4. the split level of the clause,
           5. the origin of the clause (RULE struct from clause.h).
	   Note that the justification list is empty for input
	   clauses.
***************************************************************/
{
  LIST  scan, tupel;
  TERM  term;
  NAT   bottom;

  dfg_Init(File, Flags, Precedence);  /* Initialize the parser and scanner */
  bottom = stack_Bottom();
  dfg_parse();          /* Invoke the parser */
#ifdef CHECK 
  if (!stack_Empty(bottom)) {
    misc_StartErrorReport();
    misc_ErrorReport("\n In dfg_ProofParser: Stack not empty!\n");
    misc_FinishErrorReport();
  }
#endif

  dfg_SymCleanUp();

  /* Build the union of axiom and conjecture clauses */
  dfg_AXCLAUSES  = list_Nconc(dfg_AXCLAUSES, dfg_CONCLAUSES);
  dfg_CONCLAUSES = list_Nil();
  for (scan = dfg_AXCLAUSES; !list_Empty(scan); scan = list_Cdr(scan)) {
    tupel = list_Car(scan);
    term  = list_PairSecond(tupel);
    if (list_PairFirst(tupel) == NULL) {
      /* Ignore input clauses without label */
      term_Delete(term);
      list_PairFree(tupel);
      list_Rplaca(scan, NULL);
    } else
      /* Expand the pair to a tuple                            */
      /* (label,clause,justificationlist, split level, origin) */
      /* For input clauses the justificationlist is empty.     */
      /* Input clauses have split level 0.                     */
      list_Rplacd(tupel, list_Cons(term,list_Cons(list_Nil(),list_Cons(0, list_List((POINTER)INPUT)))));
  }
  /* Now delete the list items without labels */
  dfg_AXCLAUSES = list_PointerDeleteElement(dfg_AXCLAUSES, NULL);

  /* Delete the formula lists */
  dfg_DeleteFormulaPairList(dfg_AXIOMLIST);
  dfg_DeleteFormulaPairList(dfg_CONJECLIST);
  /* Delete the list of sort declarations */
  dfg_DeleteFormulaPairList(dfg_SORTDECLLIST);
  /* Delete the list_of_terms, since it'll be ignored */
  term_DeleteTermList(dfg_TERMLIST);

  /* Finally append the proof list to the list of input clauses with labels */
  dfg_PROOFLIST = list_NReverse(dfg_PROOFLIST);
  dfg_AXCLAUSES = list_Nconc(dfg_AXCLAUSES, dfg_PROOFLIST);

  return dfg_AXCLAUSES;
}


LIST dfg_TermParser(FILE* File, FLAGSTORE Flags, PRECEDENCE Precedence)
/**************************************************************
  INPUT:   The input file containing a list of terms in DFG syntax,
           a flag store and a precedence used to memorize settings
	   from the file.
  RETURNS: The list of terms from <File>.
  EFFECT:  Reads terms from the list_of_terms from the input file.
***************************************************************/
{
  NAT bottom;
  
  dfg_Init(File, Flags, Precedence);   /* Initialize the parser and scanner */
  bottom = stack_Bottom();
  dfg_parse();          /* Invoke the parser */
#ifdef CHECK 
  if (!stack_Empty(bottom)) {
    misc_StartErrorReport();
    misc_ErrorReport("\n In dfg_TermParser: Stack not empty!\n");
    misc_FinishErrorReport();
  }
#endif

  dfg_SymCleanUp();

  /* Delete the clause lists */
  dfg_DeleteFormulaPairList(dfg_AXCLAUSES);
  dfg_DeleteFormulaPairList(dfg_CONCLAUSES);
  /* Delete the formula lists */
  dfg_DeleteFormulaPairList(dfg_AXIOMLIST);
  dfg_DeleteFormulaPairList(dfg_CONJECLIST);
  /* Delete the proof list */
  dfg_DeleteProofList(dfg_PROOFLIST);
  /* Delete the list of sort declarations */
  dfg_DeleteFormulaPairList(dfg_SORTDECLLIST);

  return dfg_TERMLIST;
}


void dfg_DeleteFormulaPairList(LIST FormulaPairs)
/**************************************************************
  INPUT:   A list of pairs (label, formula).
  RETURNS: Nothing.
  EFFECT:  The list and the pairs with their strings and terms
           are completely deleted.
***************************************************************/
{
  LIST pair;

  for ( ; !list_Empty(FormulaPairs); FormulaPairs = list_Pop(FormulaPairs)) {
    pair = list_Car(FormulaPairs);  /* (label, term) */
    term_Delete(list_PairSecond(pair));
    if (list_PairFirst(pair) != NULL)
      string_StringFree(list_PairFirst(pair));  /* Free the label */
    list_PairFree(pair);
  }
}

void dfg_StripLabelsFromList(LIST FormulaPairs)
/**************************************************************
  INPUT:   A list of pairs (label, formula).
  RETURNS: Nothing.
  EFFECT:  The pairs are replaced by the respective formula
           and the pairs with their label strings are deleted.
***************************************************************/
{
  LIST pair, scan;

  for (scan = FormulaPairs; !list_Empty(scan); scan = list_Cdr(scan)) {
    pair = list_Car(scan);  /* (label, term) */
    list_Rplaca(scan, list_PairSecond(pair));
    if (list_PairFirst(pair) != NULL)
      string_StringFree(list_PairFirst(pair));  /* Free the label */
    list_PairFree(pair);
  }
}

void dfg_DeleteProofList(LIST Proof)
/**************************************************************
  INPUT:   A list of tuples (label, term, justificationlist, split level).
  RETURNS: Nothing.
  EFFECT:  All memory used by the proof list is freed.
           The labels must NOT be NULL entries!
***************************************************************/
{
  /* Delete the proof list */
  for ( ; !list_Empty(Proof); Proof = list_Pop(Proof)) {
    LIST tupel = list_Car(Proof);
    string_StringFree(list_First(tupel));
    term_Delete(list_Second(tupel));
    dfg_DeleteStringList(list_Third(tupel));
    list_Delete(tupel);
  }
}

/**************************************************************/
/* Static Functions                                           */
/**************************************************************/

static void dfg_SymbolDecl(int SymbolType, char* Name, int Arity)
/**************************************************************
  INPUT:   The type of a symbol, the name, and the arity.
  RETURNS: Nothing.
  EFFECT:  This function handles the declaration of symbols.
           If <Arity> is -2, it means that the arity of the symbol
	   was not specified, if it is -1 the symbol is declared
	   with arbitrary arity. User defined symbols with arbitrary
           arity are not allowed.
	   The <Name> is deleted.
***************************************************************/
{
  NAT    arity, length;
  SYMBOL symbol;

  switch (Arity) {
  case -2: /* not specified */
    arity = 0;
    break;
  case -1:
    misc_StartUserErrorReport();
    misc_UserErrorReport("\n Line %u: symbols with arbitrary arity are not allowed.\n",
	    dfg_LINENUMBER);
    misc_FinishUserErrorReport();
  default:
    arity = Arity;
}

  /* Pay attention to the maximum symbol name length */
  length = strlen(Name);
  if (length >= symbol__SYMBOLMAXLEN)
    Name[symbol__SYMBOLMAXLEN-1] = '\0';

  /* Check if this symbol was declared earlier */
  symbol = symbol_Lookup(Name);
  if (symbol != 0) {
    /* Symbol was declared before */
    /* Check if the old and new symbol type are equal */
    if ((SymbolType == DFG_FUNC && !symbol_IsFunction(symbol)) ||
	(SymbolType == DFG_PRDICAT && !symbol_IsPredicate(symbol)) ||
	((SymbolType == DFG_OPERAT || SymbolType == DFG_QUANTIF) && 
	 !symbol_IsJunctor(symbol))) {
      misc_StartUserErrorReport();
      misc_UserErrorReport("\n Line %u: symbol %s was already declared as ",
	      dfg_LINENUMBER, Name);
      switch (symbol_Type(symbol)) {
      case symbol_CONSTANT:
      case symbol_FUNCTION:
	misc_UserErrorReport("function.\n"); break;
      case symbol_PREDICATE:
	misc_UserErrorReport("predicate.\n"); break;
      case symbol_JUNCTOR:
	misc_UserErrorReport("junctor.\n"); break;
      default:
	misc_UserErrorReport("unknown type.\n");
      }
      misc_FinishUserErrorReport();
    }
    /* Now check the old and new arity if specified */
    if (Arity != -2 && Arity != symbol_Arity(symbol)) {
      misc_StartUserErrorReport();
      misc_UserErrorReport("\n Line %u: symbol %s was already declared with arity %d\n",
			   dfg_LINENUMBER, Name, symbol_Arity(symbol));
      misc_FinishUserErrorReport();
    }
  } else {
    /* Symbol was not declared before */
    switch (SymbolType) {
    case DFG_FUNC:
      /* SZ > */
      /* Check whether an integer is declared, then we have to add the corresponding
	 explicit value to the symbol; otherwise, the declaration of an integer triggers
	 an error message if it is later used in the proof */
      if (string_StringIsInt(Name)) {
        if (Arity != 0) {
          misc_StartUserErrorReport();
	  misc_UserErrorReport("\n Line %u: number %s cannot be declared with non-zero arity %d\n",
                               dfg_LINENUMBER, Name, Arity);
          misc_FinishUserErrorReport();
	}
	symbol = symbol_CreateNumericFunctionFromString(Name, symbol_STATLEX,dfg_PRECEDENCE);
      } else {
	symbol = symbol_CreateFunction(Name, arity, symbol_STATLEX,dfg_PRECEDENCE);
      }
      /* < SZ */
      break;
    case DFG_PRDICAT:
      if (string_StringIsInt(Name)) {
        misc_StartUserErrorReport();
        misc_UserErrorReport("\n Line %u: number %s cannot be declared as a predicate symbol\n",
                             dfg_LINENUMBER, Name);
        misc_FinishUserErrorReport();
      }
      symbol = symbol_CreatePredicate(Name, arity,symbol_STATLEX,dfg_PRECEDENCE);
      break;
    default:
      symbol = symbol_CreateJunctor(Name, arity, symbol_STATLEX, dfg_PRECEDENCE);
    }
    if (Arity == -2)
      /* Arity wasn't specified so check the arity for each occurrence */
      dfg_SymAdd(symbol);
  }

  if (length >= symbol__SYMBOLMAXLEN) {
    /* To avoid a memory error restore the old string length */
    Name[symbol__SYMBOLMAXLEN-1] = ' ';  /* Something != '\0' */
  }
  string_StringFree(Name);  /* Name was copied */
}


static SYMBOL dfg_Symbol(char* Name, NAT Arity)
/**************************************************************
  INPUT:   The name of a symbol and the actual arity of the symbol.
  RETURNS: The corresponding SYMBOL.
  EFFECT:  This function checks if the <Name> was declared as
           symbol or variable. If not, an error message is printed
	   to stderr.
	   The <Name> is deleted.
***************************************************************/
{
  SYMBOL symbol;
  char   old;
  NAT    length;

  old = ' ';  /* Just to avoid a compiler warning */
  /* Pay attention to the maximum symbol name length */
  length = strlen(Name);
  if (length >= symbol__SYMBOLMAXLEN) {
    old = Name[symbol__SYMBOLMAXLEN-1];
    Name[symbol__SYMBOLMAXLEN-1] = '\0';
  }

  symbol = symbol_Lookup(Name);
  if (length >= symbol__SYMBOLMAXLEN) {
    /* To avoid a memory error restore the old string */
    Name[symbol__SYMBOLMAXLEN-1] = old;
  }
  if (symbol != 0) {
    string_StringFree(Name);
    dfg_SymCheck(symbol, Arity); /* Check the arity */
  } else {
    /* Variable */
    if (Arity > 0) {
      misc_StartUserErrorReport();
      misc_UserErrorReport("\n Line %d: Undefined symbol %s.\n",dfg_LINENUMBER,Name);
      misc_FinishUserErrorReport();
    }
    symbol = dfg_VarLookup(Name);
  }
  return symbol;
}


TERM dfg_CreateQuantifier(SYMBOL Symbol, LIST VarTermList, TERM Term)
/**************************************************************
  INPUT:   A quantifier symbol, a list possibly containing sorts,
           and a term.
  RETURNS: The created quantifier term..
***************************************************************/
{
  LIST varlist, sortlist, scan;
  TERM helpterm;

  /* First collect the variable symbols in varlist and the sorts in sortlist */
  varlist = sortlist = list_Nil();
  for ( ; !list_Empty(VarTermList); VarTermList = list_Pop(VarTermList)) {
    helpterm = list_Car(VarTermList);
    if (term_IsVariable(helpterm)) {
      varlist = list_Nconc(varlist, list_List((POINTER)term_TopSymbol(helpterm)));
      term_Delete(helpterm);
    } else {
      SYMBOL var = term_TopSymbol(term_FirstArgument(helpterm));
      varlist  = list_Nconc(varlist, list_List((POINTER)var));
      sortlist = list_Nconc(sortlist, list_List(helpterm));
    }
  }

  varlist = list_PointerDeleteDuplicates(varlist);
  /* Now create terms from the variables */
  for (scan = varlist; !list_Empty(scan); scan = list_Cdr(scan))
    list_Rplaca(scan, term_Create((SYMBOL)list_Car(scan), list_Nil()));

  if (!list_Empty(sortlist)) {
    if (symbol_Equal(fol_All(), Symbol)) {
      /* The conjunction of all sortterms implies the Term */
      if (symbol_Equal(fol_Or(), term_TopSymbol(Term))) {
	/* Special treatment if <Term> is a term with "or" like */
	/* in clauses: add all sort terms negated to the args    */
	/* of the "or" */
	for (scan = sortlist; !list_Empty(scan); scan = list_Cdr(scan))
	  /* Negate the sort terms */
	  list_Rplaca(scan, term_Create(fol_Not(), list_List(list_Car(scan))));
	sortlist = list_Nconc(sortlist, term_ArgumentList(Term));
	term_RplacArgumentList(Term, sortlist);
      } else {
	/* No "or" term, so build the implication term */
	if (list_Empty(list_Cdr(sortlist))) {
	  /* Only one sort term */
	  list_Rplacd(sortlist, list_List(Term));
	  Term = term_Create(fol_Implies(), sortlist);
	} else {
	  /* More than one sort term */
	  helpterm = term_Create(fol_And(), sortlist);
	  Term = term_Create(fol_Implies(), list_Cons(helpterm, list_List(Term)));
	}
      }
    } else if (symbol_Equal(fol_Exist(), Symbol)) {
      /* Quantify the conjunction of all sort terms and <Term> */
      if (symbol_Equal(fol_And(), term_TopSymbol(Term))) {
	/* Special treatment if <Term> has an "and" as top symbol: */
	/* just add the sort terms to the args of the "and".       */
	sortlist = list_Nconc(sortlist, term_ArgumentList(Term));
	term_RplacArgumentList(Term, sortlist);
      } else {
	sortlist = list_Nconc(sortlist, list_List(Term));
	Term = term_Create(fol_And(), sortlist);
      }
    }
  }
  helpterm = fol_CreateQuantifier(Symbol, varlist, list_List(Term));
  return helpterm;
}


CLAUSE dfg_CreateClauseFromTerm(TERM Clause, BOOL IsAxiom, FLAGSTORE Flags,
				PRECEDENCE Precedence)
/**************************************************************
  INPUT:   A clause term, a boolean value, a flag store and a precedence.
  RETURNS: The clause term converted to a CLAUSE or NULL if the
           clause is a trivial tautology (the clause contains
	   the literal "true" or "not(false)" ).
  EFFECT:  This function converts a clause stored as term into an
           EARL clause structure.
	   If 'IsAxiom' is TRUE the clause is treated as axiom
	   clause else as conjecture clause.
           The function deletes the literals "false" and "not(true)"
           if they occur in <Clause>.
	   The contents of the flag store and the precedence are changed
	   because the parser read flag and precedence settings from
	   
  MEMORY:  The clause term is deleted.
***************************************************************/
{
  LIST   literals, scan;
  TERM   literal;
  CLAUSE result;
  
  if (term_TopSymbol(Clause) == fol_All()) {
    /* Remove and free the quantifier and the OR term */
    literals = term_ArgumentList(term_SecondArgument(Clause));
    term_RplacArgumentList(term_SecondArgument(Clause), list_Nil());
  } else {
    /* Remove and free the OR term */
    literals = term_ArgumentList(Clause);
    term_RplacArgumentList(Clause, list_Nil());
  }
  term_Delete(Clause);

  for (scan = literals; !list_Empty(scan); scan = list_Cdr(scan)) {
    literal = (TERM) list_Car(scan);
    if (symbol_IsPredicate(term_TopSymbol(literal))) {  /* Positive literal */
      if (fol_IsTrue(literal)) {
	/* Clause is a tautology */
	list_PointerDeleteElement(literals, NULL);
	/* Remove possible NULL elements to avoid a crash in term_Delete */
	term_DeleteTermList(literals);
	return (CLAUSE) NULL;
      } else if (fol_IsFalse(literal)) {
	/* Ignore this literal */
	term_Delete(literal);
	list_Rplaca(scan, NULL); /* Mark the actual list element */
      }
    } else {
      /* Found a negative literal */
      TERM atom = term_FirstArgument(literal);
      if (fol_IsFalse(atom)) {
	/* Clause is a tautology */
	list_PointerDeleteElement(literals, NULL);
	/* Remove possible NULL elements to avoid a crash in term_Delete */
	term_DeleteTermList(literals);
	return (CLAUSE) NULL;
      } else if (fol_IsTrue(atom)) {
	/* Ignore this literal */
	term_Delete(literal);
	list_Rplaca(literals, NULL); /* Mark the actual list element */
      }
    }
  }

  literals = list_PointerDeleteElement(literals, NULL);
  /* Remove the special literals treated above from the list */
  result = clause_CreateFromLiterals(literals, FALSE, !IsAxiom, FALSE, Flags, Precedence);
  /* Don't create sorts! */
  list_Delete(literals);

  return result;
}


static void dfg_SubSort(char* Name1, char* Name2)
/**************************************************************
  INPUT:   Two sort symbol names.
  RETURNS: Nothing.
  EFFECT:  This functions adds the formula
           forall([U], implies(Name1(U), Name2(U)))
	   to the list of axiom formulas. Both <Name1> and <Name2>
	   are deleted.
***************************************************************/
{
  SYMBOL s1, s2;
  TERM   varterm, t1, t2, term;

  s1 = dfg_Symbol(Name1, 1);   /* Should be unary predicates */
  s2 = dfg_Symbol(Name2, 1);
  if (!symbol_IsPredicate(s1)) {
    misc_StartUserErrorReport();
    misc_UserErrorReport("\n Line %d: Symbol is not a sort predicate.\n", dfg_LINENUMBER);
    misc_FinishUserErrorReport();
  }
  if (!symbol_IsPredicate(s2)) {
    misc_StartUserErrorReport();
    misc_UserErrorReport("\n Line %d: Symbol is not a sort predicate.\n", dfg_LINENUMBER);
    misc_FinishUserErrorReport();
  }

  varterm = term_Create(symbol_CreateStandardVariable(), list_Nil());
  symbol_ResetStandardVarCounter();
  
  t1   = term_Create(s1, list_List(varterm));
  t2   = term_Create(s2, list_List(term_Copy(varterm)));
  term = term_Create(fol_Implies(), list_Cons(t1, list_List(t2)));
  term = fol_CreateQuantifier(fol_All(), list_List(term_Copy(varterm)),
			      list_List(term));
  dfg_SORTDECLLIST = list_Nconc(dfg_SORTDECLLIST, list_List(list_PairCreate(NULL,term)));
}


static void dfg_SymbolGenerated(SYMBOL SortPredicate, BOOL FreelyGenerated,
				LIST GeneratedBy)
/**************************************************************
  INPUT:   A sort predicate, a boolean flag, and a list of function
           symbol names.
  RETURNS: Nothing.
  EFFECT:  This function stores the information that the <SortPredicate>
           is generated by the function symbols from the <GeneratedBy>
           list. The list contains only symbol names!
	   The <SortPredicate> AND the symbols from the list get
           the property GENERATED. Additionally the symbols get
	   the property FREELY, if the flag <FreelyGenerated> is TRUE.
***************************************************************/
{
  SYMBOL symbol;
  LIST   scan;

  if (!symbol_IsPredicate(SortPredicate)) {
    misc_StartUserErrorReport();
    misc_UserErrorReport("\n Line %d: Symbol is not a sort predicate.\n", dfg_LINENUMBER);
    misc_FinishUserErrorReport();
  }
  /* First reset the old information */
  symbol_RemoveProperty(SortPredicate, GENERATED);
  symbol_RemoveProperty(SortPredicate, FREELY);
  list_Delete(symbol_GeneratedBy(SortPredicate));
  /* Now set the new information */
  symbol_AddProperty(SortPredicate, GENERATED);
  if (FreelyGenerated)
    symbol_AddProperty(SortPredicate, FREELY);
  for (scan = GeneratedBy; !list_Empty(scan); scan = list_Cdr(scan)) {
    symbol = symbol_Lookup(list_Car(scan));
    if (symbol == 0) {
      misc_StartUserErrorReport();
      misc_UserErrorReport("\n Line %d: undefined symbol %s.\n", dfg_LINENUMBER,
			   (char*)list_Car(scan));
      misc_FinishUserErrorReport();
    } else if (!symbol_IsFunction(symbol)) { /* must be function or constant */
      misc_StartUserErrorReport();
      misc_UserErrorReport("\n Line %d: Symbol is not a function.\n", dfg_LINENUMBER);
      misc_FinishUserErrorReport();
    }
    string_StringFree(list_Car(scan));
    list_Rplaca(scan, (POINTER)symbol);  /* change the name list to a symbol list */
    /* Set GENERATED properties for generating symbols */
    symbol_AddProperty(symbol, GENERATED);
    if (FreelyGenerated)
      symbol_AddProperty(symbol, FREELY);
  }
  symbol_SetGeneratedBy(SortPredicate, GeneratedBy);
}


/**************************************************************/
/* Functions for the Symbol Table                             */
/**************************************************************/

typedef struct {
  SYMBOL symbol;
  BOOL   valid;
  int    arity;
} DFG_SYMENTRY, *DFG_SYM;

static __inline__ DFG_SYM dfg_SymCreate(void)
{
  return (DFG_SYM) memory_Malloc(sizeof(DFG_SYMENTRY));
}

static __inline__ void dfg_SymFree(DFG_SYM Entry)
{
  memory_Free(Entry, sizeof(DFG_SYMENTRY));
}


static void dfg_SymAdd(SYMBOL Symbol)
/**************************************************************
  INPUT:   A symbol.
  RETURNS: Nothing.
  EFFECT:  This function adds 'Symbol' to the symbol list.
           The arity of these symbols will be checked every time
	   the symbol occurs.
***************************************************************/
{
  DFG_SYM newEntry = dfg_SymCreate();
  newEntry->symbol = Symbol;
  newEntry->valid  = FALSE;
  newEntry->arity  = 0;
  dfg_SYMBOLLIST = list_Cons(newEntry, dfg_SYMBOLLIST);
}


static void dfg_SymCheck(SYMBOL Symbol, NAT Arity)
/**************************************************************
  INPUT:   A symbol and the current arity of this symbol.
  RETURNS: Nothing.
  EFFECT:  This function compares the previous arity of 'Symbol'
           with the actual 'Arity'. If these values differ
	   the symbol's arity is set to arbitrary.
	   The arity of symbols whose arity was specified in
	   the symbol declaration section is checked and a warning
	   is printed to stderr in case of differences.
***************************************************************/
{
  LIST scan = dfg_SYMBOLLIST;
  while (!list_Empty(scan)) {
    DFG_SYM actEntry = (DFG_SYM) list_Car(scan);
    if (actEntry->symbol == Symbol) {
      if (actEntry->valid) {
	if (actEntry->arity != Arity) {
	  misc_StartUserErrorReport();
	  misc_UserErrorReport("\n Line %u:", dfg_LINENUMBER);
	  misc_UserErrorReport(" The actual arity %u", Arity);
	  misc_UserErrorReport(" of symbol %s differs", symbol_Name(Symbol));
	  misc_UserErrorReport(" from the previous arity %u.\n", actEntry->arity);
	  misc_FinishUserErrorReport();
	}
      } else {
	/* Not valid => first time */
	actEntry->arity = Arity;
	actEntry->valid = TRUE;
      }
      return;
    }
    scan = list_Cdr(scan);
  }

  /* Symbol isn't in SymbolList, so its arity was specified.        */
  /* Check if the specified arity corresponds with the actual arity */
  if (symbol_Arity(Symbol) != Arity) {
    misc_StartUserErrorReport();
    misc_UserErrorReport("\n Line %u: Symbol %s was declared with arity %u.\n",
			 dfg_LINENUMBER, symbol_Name(Symbol), symbol_Arity(Symbol));
    misc_FinishUserErrorReport();
  }
}


static void dfg_SymCleanUp(void)
/**************************************************************
  INPUT:   None.
  RETURNS: Nothing.
  EFFECT:  This function corrects all symbols whose arity wasn't
           specified in the symbol declaration section but seem
	   to occur with always the same arity.
	   The memory for the symbol list is freed.
***************************************************************/
{
  while (!list_Empty(dfg_SYMBOLLIST)) {
    DFG_SYM actEntry  = (DFG_SYM) list_Car(dfg_SYMBOLLIST);
    SYMBOL  actSymbol = actEntry->symbol;

    if (actEntry->arity != symbol_Arity(actSymbol))
      symbol_SetArity(actSymbol, actEntry->arity);

    dfg_SymFree(actEntry);
    dfg_SYMBOLLIST = list_Pop(dfg_SYMBOLLIST);
  }
}


/**************************************************************/
/* Functions for the Variable Table                           */
/**************************************************************/
  
typedef struct {
  char*  name;
  SYMBOL symbol;
} DFG_VARENTRY, *DFG_VAR;

static __inline__ char* dfg_VarName(DFG_VAR Entry)
{
  return Entry->name;
}

static __inline__ SYMBOL dfg_VarSymbol(DFG_VAR Entry)
{
  return Entry->symbol;
}

static __inline__ DFG_VAR dfg_VarCreate(void)
{
  return (DFG_VAR) memory_Malloc(sizeof(DFG_VARENTRY));
}

static void dfg_VarFree(DFG_VAR Entry)
{
  string_StringFree(Entry->name);
  memory_Free(Entry, sizeof(DFG_VARENTRY));
}

static void dfg_VarStart(void)
{
  dfg_VARLIST = list_Push(list_Nil(), dfg_VARLIST);
  dfg_VARDECL = TRUE;
}

static void dfg_VarStop(void)
{
  dfg_VARDECL = FALSE;
}

static void dfg_VarBacktrack(void)
{
  list_DeleteWithElement(list_Top(dfg_VARLIST), (void (*)(POINTER)) dfg_VarFree);
  dfg_VARLIST = list_Pop(dfg_VARLIST);
}

static void dfg_VarCheck(void)
/* Should be called after a complete clause or formula was parsed */
{
  if (!list_Empty(dfg_VARLIST)) {
    misc_StartErrorReport();
    misc_ErrorReport("\n In dfg_VarCheck: List of variables should be empty!\n");
    misc_FinishErrorReport();
  }
  symbol_ResetStandardVarCounter();
}

static SYMBOL dfg_VarLookup(char* Name)
/**************************************************************
  INPUT:   A variable name.
  RETURNS: The corresponding variable symbol.
  EFFECT:  If the variable name was quantified before, the
           corresponding symbol is returned and the <Name> is freed.
	   If the variable name was not quantified, and <dfg_VARDECL>
	   is TRUE, a new variable is created, else an error
	   message is printed and the program exits.
***************************************************************/
{
  LIST   scan, scan2;
  SYMBOL symbol = symbol_Null();

  scan  = dfg_VARLIST;
  scan2 = list_Nil();
  while (!list_Empty(scan) && list_Empty(scan2)) {
    scan2 = list_Car(scan);
    while (!list_Empty(scan2) &&
	   (!string_Equal(dfg_VarName(list_Car(scan2)), Name)))
      scan2 = list_Cdr(scan2);
    scan = list_Cdr(scan);
  }

  if (!list_Empty(scan2)) {
    /* Found variable */
    string_StringFree(Name);
    symbol = dfg_VarSymbol(list_Car(scan2));
  } else {
    /* Variable not found */
    if (dfg_VARDECL) {
      DFG_VAR newEntry = dfg_VarCreate();
      newEntry->name   = Name;
      newEntry->symbol = symbol_CreateStandardVariable();
      /* Add <newentry> to the first list in dfg_VARLIST */
      list_Rplaca(dfg_VARLIST, list_Cons(newEntry,list_Car(dfg_VARLIST)));
      symbol = dfg_VarSymbol(newEntry);
    /* (UW) */
    } else if (/* SZ > */ gmp_StringIsMPN(Name) /* < SZ */ ) {
      symbol = symbol_CreateNumericFunctionFromString(Name, symbol_STATLEX, dfg_PRECEDENCE);
      string_StringFree(Name);
    } else {
      misc_StartUserErrorReport();
      misc_UserErrorReport("\n Line %u: Free Variable %s.\n", dfg_LINENUMBER, Name);
      misc_FinishUserErrorReport();
    }
  }
  return symbol;
}

